package org.ow2.choreos.iots.common;

public class BorderPoints {

	public Point myBottomLeft, myBottomRight, myUpperLeft, myUpperRight;

	/**
	 * BorderPoints object specifies the coordinates of the four edges around a
	 * rectangle: bottomLeft, bottomRight, upperLeft, upperRight.
	 * 
	 * @param bottomLeft
	 * @param bottomRight
	 * @param upperLeft
	 * @param upperRight
	 */
	public BorderPoints(Point bottomLeft, Point bottomRight, Point upperLeft,
			Point upperRight) {
		myBottomLeft = bottomLeft;
		myBottomRight = bottomRight;
		myUpperLeft = upperLeft;
		myUpperRight = upperRight;

	}

	public Point getUpperLeftPoint() {
		return myUpperLeft;
	}

	public Point getUpperRightPoint() {
		return myUpperRight;
	}

	public Point getBottomLeftPoint() {
		return myBottomLeft;
	}

	public Point getBottomRightPoint() {
		return myBottomRight;
	}

	public double getWidth() {
		double width = myBottomRight.getX() - myBottomLeft.getX();
		return width;
	}
	public double getHeight() {
		double height = myUpperLeft.getY() - myBottomLeft.getY();
		return height;
	}
	
	public double getArea() {
		
		return getWidth() * getHeight();
	}
}
