package org.ow2.choreos.iots.common;

import java.util.ArrayList;
import java.util.List;

import org.json.simple.JSONObject;

public class ServiceDescription {

	private static final String ACCURACY = "accuracy";
	private static final String ADDRESS = "address";
	private static final String NAME = "name";
	private static final String DEVICEID = "DeviceId";
	private static final String TYPE = "type";
	private static final String X = "coordinateX";
	private static final String Y = "coordinateY";
	private static final String GLOBALREGION = "global_region";
	private static final String RANGE = "range";
	private static final String SENSOR = "sensor";
	private static final String CONCEPT = "concept";
	private static final String DATATYPE = "dataType";
	private static final String UNIT = "unit";
	private static final String ESTIMATEDPATH = "estimated_path";
	String deviceID;
	String address;
	String name;
	String type;
	Double accuracy;
	double locationX, locationY;
	String globalRegion;
	Double range;
	String sensor;
	String concept;
	String dataType;
	String unit;
	String estimatedPath;

	public ServiceDescription() {
		// empty cons. needed for deserialization
	}

	public ServiceDescription(String deviceID, String address, String name,
			String type, double accuracy, String globalRegion, double range,
			String sensor, String concept, String dataType,
			double locationCoordinateX, double locationCoordinateY,
			String unit, String estimatedPath) {
		super();
		this.deviceID = deviceID;
		this.address = address;
		this.name = name;
		this.type = type;
		this.accuracy = accuracy;
		this.locationX = locationCoordinateX;
		this.locationY = locationCoordinateY;
		this.globalRegion = globalRegion;
		this.range = range;
		this.sensor = sensor;
		this.concept = concept;
		this.dataType = dataType;
		this.unit = unit;
		this.estimatedPath = estimatedPath;

	}

	public String getDeviceID() {
		return deviceID;
	}

	public String getAddress() {
		return address;
	}

	public String getName() {
		return name;
	}

	public String getType() {
		return type;
	}

	public double getAccuracy() {
		return accuracy;
	}

	public double getLocationX() {
		return locationX;
	}

	public void setLocationX(double x) {
		this.locationX = x;
	}

	public void setLocationY(double y) {
		this.locationY = y;
	}

	public double getLocationY() {
		return locationY;
	}

	public String getGlobalRegion() {
		return globalRegion;
	}

	public double getRange() {
		return range;
	}

	public String getSensor() {
		return sensor;
	}

	public String getConcept() {
		return concept;
	}

	public String getDataType() {
		return dataType;
	}

	public String getUnit() {
		return unit;
	}

	public String getEstimatedPath() {
		return estimatedPath;
	}

	public JSONObject serializeAsJSON() {
		JSONObject ret = new JSONObject();

		ret.put(ACCURACY, accuracy);
		ret.put(ADDRESS, address);
		ret.put(NAME, name);
		ret.put(CONCEPT, concept);
		ret.put(DEVICEID, deviceID);
		ret.put(GLOBALREGION, globalRegion);
		ret.put(X, locationX);
		ret.put(Y, locationY);
		ret.put(RANGE, range);
		ret.put(SENSOR, sensor);
		ret.put(TYPE, type);
		ret.put(DATATYPE, dataType);
		ret.put(UNIT, unit);
		ret.put(ESTIMATEDPATH, estimatedPath);
		return ret;

	}

	public static ServiceDescription deserializeFromJSONObject(JSONObject j) {
		ServiceDescription temp = new ServiceDescription();

		temp.accuracy = Double.parseDouble(j.get(ACCURACY).toString());
		temp.address = j.get(ADDRESS).toString();
		temp.name = j.get(NAME).toString();
		temp.concept = j.get(CONCEPT).toString();
		temp.deviceID = j.get(DEVICEID).toString();
		temp.globalRegion = j.get(GLOBALREGION).toString();
		temp.locationX = Double.parseDouble(j.get(X).toString());
		temp.locationY = Double.parseDouble(j.get(Y).toString());
		temp.range = Double.parseDouble(j.get(RANGE).toString());

		temp.sensor = j.get(SENSOR).toString();
		temp.type = j.get(TYPE).toString();
		temp.dataType = j.get(DATATYPE).toString();
		temp.unit = j.get(UNIT).toString();
		temp.estimatedPath = j.get(ESTIMATEDPATH).toString();
		return temp;

	}

}
