package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultBooleanData extends BooleanData {

	private static final long serialVersionUID = -6067451962406761846L;
	protected static final String UID = "org.ow2.choreos.sensordata.boolean";
	protected static final String INTERFACE = "org.ow2.choreos.sensordata.boolean";

	public DefaultBooleanData(JSONObject j){
		super(j);
	}
	public DefaultBooleanData(Boolean value, long timestamp) {
		super(value, timestamp);
	}

	@Override
	public SensorData fromStringArray(String[] sa) {
		return (SensorData) (new DefaultBooleanData(Boolean.parseBoolean(sa[1]), Long.parseLong(sa[0])));
	}

	@Override
	public String[] getComponentNames() {
		String[] s = new String[2];
		s[0] = "timestamp";
		s[1] = "value";
		return s;
	}

	@Override
	public boolean isFresh() {
		return true;
	}
	
	@Override
	public SensorData copy() {
		// since this class is immutable, just return the current instance
		return this;
	}
	
	@Override
	public String getUid() {
		return UID;
	}
	
	@Override
	public String getInterface() {
		return INTERFACE;
	}

	@Override
	public JSONObject serializeAsJSON() {
		JSONObject ret = super.serializeAsJSON();

		return ret;
	}
	@Override
	public String toString() {
		// TODO Auto-generated method stub
		return value.toString();
	}


}

