package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultDouble2dData extends Double2dData {

	private static final long serialVersionUID = 6816725778574595671L;
	protected static final String UID = "org.ow2.choreos.sensordata.2d-double";
	protected static final String INTERFACE = "org.ow2.choreos.sensordata.2d-double";

	public DefaultDouble2dData(JSONObject j) {
		super(j);
	}
	
	public DefaultDouble2dData(double x, double y, long t) {
		super(x, y, t);
	}

	@Override
	public SensorData fromStringArray(String[] sa) {
		return (SensorData) (new DefaultDouble2dData(Double.parseDouble(sa[0]),
				Double.parseDouble(sa[1]), Long.parseLong(sa[2])));
	}

	@Override
	public String[] getComponentNames() {
		String[] s = new String[3];
		s[0] = "x";
		s[1] = "y";
		s[2] = "timestamp";
		return s;
	}

	@Override
	public boolean isFresh() {
		return true;
	}

	@Override
	public SensorData copy() {
		// since this class is immutable, just return the current instance
		return this;
	}

	@Override
	public String getUid() {
		return UID;
	}

	@Override
	public String getInterface() {
		return INTERFACE;
	}
	@Override
	public JSONObject serializeAsJSON() {
		JSONObject ret = super.serializeAsJSON();
		return ret;
	}

}
