package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultDoubleData extends DoubleData {

	private static final long serialVersionUID = 6927592376981831812L;
	protected static final String UID = "org.ow2.choreos.sensordata.double";
	protected static final String INTERFACE = "org.ow2.choreos.sensordata.double";

	public DefaultDoubleData(JSONObject j) {
		super(j);

	}

	public DefaultDoubleData(double value, long timestamp) {
		super(value, timestamp);
	}

	@Override
	public SensorData fromStringArray(String[] sa) {
		return (SensorData) (new DefaultDoubleData(Double.parseDouble(sa[1]),
				Long.parseLong(sa[0])));
	}

	@Override
	public String[] getComponentNames() {
		String[] s = new String[2];
		s[0] = "timestamp";
		s[1] = "value";
		return s;
	}

	@Override
	public boolean isFresh() {
		return true;
	}

	@Override
	public SensorData copy() {
		// since this class is immutable, just return the current instance
		return this;
	}

	@Override
	public String getUid() {
		return UID;
	}

	@Override
	public String getInterface() {
		return INTERFACE;
	}

	@Override
	public JSONObject serializeAsJSON() {
		JSONObject ret = super.serializeAsJSON();

		return ret;
	}

}
