package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultDoubleTemperatureFahrenheitData extends DefaultDoubleData {
	
	private static final long serialVersionUID = -3889806809081793607L;
	protected static final String UID = "org.ow2.choreos.sensordata.double.fahrenheit.temperature";
	protected static final String INTERFACE = "org.ow2.choreos.sensordata.double.fahrenheit.temperature";
	
	public DefaultDoubleTemperatureFahrenheitData(JSONObject j) {
		super(j);
	}
	
	public DefaultDoubleTemperatureFahrenheitData(double noiselevel_dB, long timestamp) {
		super(noiselevel_dB, timestamp);
	}

	@Override
	public SensorData fromStringArray(String[] sa) {
		return (SensorData) (new DefaultDoubleTemperatureFahrenheitData(Double.parseDouble(sa[1]), Long.parseLong(sa[0])));
	}

	@Override
	public String[] getComponentNames() {
		String[] s = new String[2];
		s[0] = "timestamp";
		s[1] = "degreeF";
		return s;
	}

  @Override
	public String getUid() {
		return UID;
	}
	
	public double getNoiseLevel() {
		return super.getValue();
	}
	
	@Override
	public JSONObject serializeAsJSON() {
		JSONObject ret = super.serializeAsJSON();

		return ret;
	}

}
