package org.ow2.choreos.iots.datatypes;

import org.ow2.choreos.iots.common.Constants;
import java.util.Date;

import org.json.simple.JSONObject;
public abstract class Double2dData extends SensorData {

	private static final long serialVersionUID = 5508555229342582371L;

	protected final double x;
	protected final double y;
	private static final String X = Constants.XVAL;;
	private static final String Y = Constants.YVAL;

	
	public Double2dData(JSONObject j) {
		super(j);
		this.x = Double.parseDouble(j.get(X).toString());
		this.y = Double.parseDouble(j.get(Y).toString());

	}

	public Double2dData(double x, double y, long t) {
		super(t);
		this.x = x;
		this.y = y;
	}

	public double getX() {
		return x;
	}

	public double getY() {
		return y;
	}

	@Override
	public String toString() {
		return "x:" + Double.toString(x) + " y:" + Double.toString(y)
				+ " timestamp:" + Long.toString(timestamp);
	}

	@Override
	public String[] toStringArray() {
		String[] s = new String[3];
		s[0] = Double.toString(x);
		s[1] = Double.toString(y);
		s[2] = Long.toString(timestamp);
		return s;
	}
	@Override
	public JSONObject serializeAsJSON() {
		JSONObject ret = super.serializeAsJSON();

		ret.put(X, this.x);
		ret.put(Y, this.y);
		return ret;
	}

}
