package org.ow2.choreos.iots.datatypes;

import org.ow2.choreos.iots.common.Constants;
import org.json.simple.JSONObject;
public abstract class Double3dData extends SensorData {

	private static final long serialVersionUID = 8205724392915403983L;

	protected final double x;
	protected final double y;
	protected final double z;
	private static final String X = Constants.XVAL;
	private static final String Y = Constants.YVAL;
	private static final String Z= Constants.ZVAL;

	public Double3dData(JSONObject j) {
		super(j);
		this.x = Double.parseDouble(j.get(X).toString());
		this.y = Double.parseDouble(j.get(Y).toString());
		this.z = Double.parseDouble(j.get(Z).toString());
	}
	
	public Double3dData(double x, double y, double z, long t) {
		super(t);
		this.x = x;
		this.y = y;
		this.z = z;
	}

	public double getX() {
		return x;
	}

	public double getZ() {
		return z;
	}

	public double getY() {
		return y;
	}

	@Override
	public String toString() {
		return  "x:" + Double.toString(x) +
		       " y:" + Double.toString(y) +
		       " z:" + Double.toString(z) +
		       " timestamp:" + Long.toString(timestamp);
	}
	
	@Override
	public String[] toStringArray() {
		String[] s = new String[4];
		s[0] = Long.toString(timestamp);
		s[1] = Double.toString(x);
		s[2] = Double.toString(y);
		s[3] = Double.toString(z);
		return s;
	}
	public JSONObject serializeAsJSON() {
		JSONObject ret = super.serializeAsJSON();
		ret.put(X, this.x);
		ret.put(Y, this.y);
		ret.put(Z, this.z);
		return ret;
	}
}


