package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;
import org.ow2.choreos.iots.common.Constants;


public abstract class DoubleData extends SensorData {

	private static final long serialVersionUID = 6927592376981831812L;

	protected final double value;
	private static final String VALUE = Constants.DOUBLEVALUE;

	// long time;

	public DoubleData(JSONObject j) {
		super(j);
		this.value = Double.parseDouble(j.get(VALUE).toString());
	}

	public DoubleData(double value, long timestamp) {
		super(timestamp);
		this.value = value;
	}

	public double getValue() {
		return value;
	}

	@Override
	public String toString() {
		return Double.toString(value);
	}

	@Override
	public String[] toStringArray() {
		String[] s = new String[2];
		s[0] = Long.toString(timestamp);
		s[1] = Double.toString(value);
		return s;
	}

	@Override
	public JSONObject serializeAsJSON() {
		JSONObject ret = super.serializeAsJSON();

		ret.put(VALUE, this.value);

		return ret;
	}
}
