package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;
import org.ow2.choreos.iots.common.Constants;


public abstract class IntegerData extends SensorData {

	private static final long serialVersionUID = -6067451962406761846L;

	protected final int value;
	private static final String VALUE = Constants.INTVALUE;
public IntegerData(JSONObject j){
	super(j);
	this.value = Integer.parseInt(j.get(VALUE).toString());
}
	public IntegerData(int value, long timestamp) {
		super(timestamp);
		this.value = value;
	}

	public int getValue() {
		return value;
	}

	@Override
	public String toString() {
		return Integer.toString(value);
	}

	@Override
	public String[] toStringArray() {
		String[] s = new String[2];
		s[0] = Long.toString(timestamp);
		s[1] = Integer.toString(value);
		return s;
	}

@Override
public JSONObject serializeAsJSON() {
	JSONObject ret = super.serializeAsJSON();

	ret.put(VALUE, this.value);
	

	return ret;
}
}

