/**
 * @author Kostas Lekkas -- lekkas@vtrip.net
 */
package net.vtrip.things;

public class RequestExpiredEvent implements Runnable {

    private String deviceID;
    private String serviceName;
    private String replyKey;
    private Object lock;
    private static int glob_id = 1;
    private int id;
    
    public RequestExpiredEvent(String replyKey, Object lock) {
        id = ++glob_id;
        this.replyKey = replyKey;
        this.lock = lock;
        int i = replyKey.indexOf("-");
        serviceName = replyKey.substring(i + 1);
        deviceID = replyKey.substring(0, i);
        System.out.println(+id+": Scheduled requestExpiredEvent for "+deviceID+" "+serviceName);
    }
            
    public void run() {
        synchronized(lock) {
            System.out.println(+id+": RequestExpiredEvent fired for "+replyKey);
            Resources.requests.get(deviceID).remove(serviceName);
            Resources.replies.remove(replyKey);
        }
    }
    
}
