/**
 * @author Kostas Lekkas -- lekkas@vtrip.net
 */
package net.vtrip.things;

import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.ScheduledFuture;

public class SensorDataReply {
    private String reply;
    private ScheduledFuture requestExpireTimeoutTask;
    private LinkedBlockingQueue<Boolean> newReplyQ; // this queue is used for synchronization between consumers 
                                                    // (sensor data requests) and producers (sensor data responses)

    public SensorDataReply(String reply) {
        this.reply = reply;
        this.requestExpireTimeoutTask = null;
        newReplyQ = new LinkedBlockingQueue<Boolean>();
    }
    
    public ScheduledFuture getRequestExpireTimeoutTask() {
        return requestExpireTimeoutTask;
    }

    public void setRequestExpireTimeoutTask(ScheduledFuture requestExpireTimeoutTask) {
        this.requestExpireTimeoutTask = requestExpireTimeoutTask;
    }

    public String getReply() {
        return reply;
    }

    public void setReply(String reply) {
        this.reply = reply;
    }
    
    public LinkedBlockingQueue<Boolean> getNewReplyQ() {
        return newReplyQ;
    }
}
