package test.java.services;

import java.util.ArrayList;
import java.util.Random;

import org.json.simple.JSONObject;

/**
 * Class for Location Service.
 * 
 * @author lekkas@vtrip.net
 *
 */
public class LocationService implements Service {

	private final String name = "getlocation";
	private static final Random r = new Random(System.currentTimeMillis());
	private String deviceID;
	
	public LocationService(String deviceID) {
		this.deviceID = deviceID;
	}

	private double dummylatitude = 37.982211;
	private double dummylongitude = 23.730319;
	
	
	@Override
	public String getName() {
		return name;
	}

	@Override
	public String getJSONData() {
		
		JSONObject obj = new JSONObject();
		JSONObject response = new JSONObject();
		
		ArrayList<Double> lst = getDummyLocation(dummylatitude, dummylongitude);
		response.put("dataType", "org.ow2.choreos.sensordata.2d-double.location");
		response.put("timestamp", 0);
		response.put("x", lst.remove(0));
		response.put("y", lst.remove(0));

		obj.put("sensorDataResponse", response);
		
		return obj.toJSONString();
	}
	
	private ArrayList<Double> getDummyLocation(double lat, double lon) {
		double density = 500.0;
		
		double dummyLat = lat + (r.nextDouble() / density) - 0.5 / density;
		double dummyLon = lon + (r.nextDouble() / density) - 0.5 / density;
		
		ArrayList<Double> lst = new ArrayList<Double>();
		lst.add(new Double(dummyLat));
		lst.add(new Double(dummyLon));
		return lst;
	}

}
	
