package test.java.services;

import java.text.DecimalFormat;
import java.util.Random;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

/**
 * Class for Noise level service
 * 
 * @author lekkas@vtrip.net
 *
 */
public class NoiseLevelService implements Service {

	private final String name = "getnoiselevel";
	private static final Random r = new Random(System.currentTimeMillis());
	private String deviceID;
	
	
	public NoiseLevelService(String deviceID) {
		this.deviceID = deviceID;
	}
	
	@Override
	public String getName() {
		return name;
	}

	@Override
	public String getJSONData() {
		String data = createJSONData();
		return data;
	}
	
	private String createJSONData() {
		DecimalFormat dec = new DecimalFormat("##.###");
		String randNoiseVal = dec.format(-r.nextFloat()*95);
		
		JSONObject obj = new JSONObject();
		JSONObject response = new JSONObject();
/*
		response.put("dataType", "org.ow2.choreos.sensordata.double.noiselevel");
		response.put("timestamp", 0);
		response.put("value", randNoiseVal);
*/
		/*
		 * New version of sensordata JSON object
		 */
		response.put("sensor","noiselevel_sensor");
		response.put("unit","db");
		response.put("DeviceId",deviceID);
		response.put("dataType", "org.ow2.choreos.sensordata.double.noiselevel");
		response.put("concept","noiselevel");
		response.put("dataDouble",randNoiseVal);
		response.put("name","genoiselevel");
		response.put("dataString","");
		response.put("global_region","Paris");
		response.put("address", "http://192.168.2.61:8080/PhoneServicesProxy-1.0/"+deviceID+"/getnoiselevel");
		
		JSONArray respArray = new JSONArray();
		respArray.add(response);
		
		obj.put("sensorDataResponse", respArray);
		
		return obj.toJSONString();
	}
}
