package org.ow2.choreos.datarepository;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.ow2.choreos.iots.common.Constants;

/**
 * Servlet implementation class AddData
 */
public class AddData extends HttpServlet {
	private static final long serialVersionUID = 1L;

	/**
	 * @see HttpServlet#HttpServlet()
	 */
	public AddData() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		PrintWriter pr = response.getWriter();
		String dataString = "";
		String dataType = request.getParameter("dataType");
		if (dataType.equals(Constants.DOUBLE)) {
			String serviceAddress = request.getParameter("address");
			String deviceIdString = request.getParameter("device_id");
			String serviceName = request.getParameter("name");
			String dataDoubleString = request.getParameter("dataDouble");
			String sensorType = request.getParameter("sensor");
			String unit = request.getParameter("unit");
			String globalRegion = request.getParameter("global_region");
			String concept = request.getParameter("concept");
			String xCoord = request.getParameter("x_coordinate");
			String yCoord = request.getParameter("y_coordinate");

			if ((serviceAddress == null) || (deviceIdString == null)
					|| (serviceName == null) || (dataString == null)
					|| (unit == null) || (dataDoubleString == null)
					|| (sensorType == null) || (globalRegion == null)
					|| (concept == null) || (dataType == null)
					|| (xCoord == null) || (yCoord == null)) {
				response.sendError(500);
				return;

			}

			try {
				// int deviceId = Integer.parseInt(deviceIdString);

				double dataDouble = Double.parseDouble(dataDoubleString);
				double xCoordDouble = Double.parseDouble(xCoord);
				double yCoordDouble = Double.parseDouble(yCoord);
				boolean result = Repository.add(serviceAddress, deviceIdString,

				serviceName, unit, dataDouble, dataString, sensorType,
						globalRegion, concept, dataType, xCoordDouble,
						yCoordDouble);
				if (result == true) {
					pr.print(true);
					response.setStatus(200);
				}

				else {
					pr.print(false);
					response.sendError(400);

				}

			} catch (Exception e) {
				pr.print(false);
				response.sendError(500);
			}
		}

		else if (dataType.equals(Constants.DOUBLE2D)
				|| dataType.equals(Constants.DOUBLE2DLOCATION)) {
			String serviceAddress = request.getParameter("address");
			String deviceIdString = request.getParameter("device_id");
			String serviceName = request.getParameter("name");
			String dataDoubleString1 = request.getParameter("dataDouble1");
			String dataDoubleString2 = request.getParameter("dataDouble2");
			String sensorType = request.getParameter("sensor");
			String unit = request.getParameter("unit");
			String globalRegion = request.getParameter("global_region");
			String concept = request.getParameter("concept");
			String xCoord = request.getParameter("x_coordinate");
			String yCoord = request.getParameter("y_coordinate");
			if ((serviceAddress == null) || (deviceIdString == null)
					|| (serviceName == null) || (dataString == null)
					|| (unit == null) || (dataDoubleString1 == null)
					|| (dataDoubleString1 == null) || (sensorType == null)
					|| (globalRegion == null) || (concept == null)
					|| (dataType == null) || (xCoord == null)
					|| (yCoord == null)) {
				response.sendError(500);
				return;

			}

			try {
				double xCoordDouble = Double.parseDouble(xCoord);
				double yCoordDouble = Double.parseDouble(yCoord);
				double dataDouble1 = Double.parseDouble(dataDoubleString1);
				double dataDouble2 = Double.parseDouble(dataDoubleString2);
				boolean result = Repository.add(serviceAddress, deviceIdString,

				serviceName, unit, dataDouble1, dataDouble2, dataString,
						sensorType, globalRegion, concept, dataType,
						xCoordDouble, yCoordDouble);
				if (result == true) {
					pr.print(true);
					response.setStatus(200);
				}

				else {
					pr.print(false);
					response.sendError(400);

				}

			} catch (Exception e) {
				pr.print(false);
				response.sendError(500);
			}
		}

		else if (dataType.equals(Constants.DOUBLE3D)) {
			String serviceAddress = request.getParameter("address");
			String deviceIdString = request.getParameter("device_id");
			String serviceName = request.getParameter("name");
			String dataDoubleString1 = request.getParameter("dataDouble1");
			String dataDoubleString2 = request.getParameter("dataDouble2");

			String dataDoubleString3 = request.getParameter("dataDouble3");
			String sensorType = request.getParameter("sensor");
			String unit = request.getParameter("unit");
			String globalRegion = request.getParameter("global_region");
			String concept = request.getParameter("concept");
			String xCoord = request.getParameter("x_coordinate");
			String yCoord = request.getParameter("y_coordinate");
			if ((serviceAddress == null) || (deviceIdString == null)
					|| (serviceName == null) || (dataString == null)
					|| (unit == null) || (dataDoubleString1 == null)
					|| (dataDoubleString1 == null) || (sensorType == null)
					|| (globalRegion == null) || (concept == null)
					|| (dataType == null) || (xCoord == null)
					|| (yCoord == null)) {
				response.sendError(500);
				return;

			}

			try {
				double xCoordDouble = Double.parseDouble(xCoord);
				double yCoordDouble = Double.parseDouble(yCoord);
				double dataDouble1 = Double.parseDouble(dataDoubleString1);
				double dataDouble2 = Double.parseDouble(dataDoubleString2);
				double dataDouble3 = Double.parseDouble(dataDoubleString3);
				boolean result = Repository.add(serviceAddress, deviceIdString,

				serviceName, unit, dataDouble1, dataDouble2, dataDouble3,
						dataString, sensorType, globalRegion, concept,
						dataType, xCoordDouble, yCoordDouble);
				if (result == true) {
					pr.print(true);
					response.setStatus(200);
				}

				else {
					pr.print(false);
					response.sendError(400);

				}

			} catch (Exception e) {
				pr.print(false);
				response.sendError(500);
			}
		}

		else if (dataType.equals(Constants.LONG)) {
			String serviceAddress = request.getParameter("address");
			String deviceIdString = request.getParameter("device_id");
			String serviceName = request.getParameter("name");
			String dataLongString = request.getParameter("dataLong");
			String sensorType = request.getParameter("sensor");
			String unit = request.getParameter("unit");
			String globalRegion = request.getParameter("global_region");
			String concept = request.getParameter("concept");
			String xCoord = request.getParameter("x_coordinate");
			String yCoord = request.getParameter("y_coordinate");
			if ((serviceAddress == null) || (deviceIdString == null)
					|| (serviceName == null) || (dataString == null)
					|| (unit == null) || (dataLongString == null)
					|| (sensorType == null) || (globalRegion == null)
					|| (concept == null) || (dataType == null)
					|| (xCoord == null) || (yCoord == null)) {
				response.sendError(500);
				return;

			}

			try {
				double xCoordDouble = Double.parseDouble(xCoord);
				double yCoordDouble = Double.parseDouble(yCoord);
				long dataLong = Long.parseLong(dataLongString.toString());
				boolean result = Repository.add(serviceAddress, deviceIdString,
						serviceName, unit, dataLong, dataString, sensorType,
						globalRegion, concept, dataType, xCoordDouble,
						yCoordDouble);
				if (result == true) {
					pr.print(true);
					response.setStatus(200);
				}

				else {
					pr.print(false);
					response.sendError(400);

				}

			} catch (Exception e) {
				pr.print(false);
				response.sendError(500);
			}
		}

		else if (dataType.equals(Constants.DOUBLENOISE) || dataType.equals(Constants.DOUBLEPRESSUREPA)) {
			String serviceAddress = request.getParameter("address");
			String deviceIdString = request.getParameter("device_id");
			String serviceName = request.getParameter("name");
			String dataDoubleString = request.getParameter("dataDouble");
			String sensorType = request.getParameter("sensor");
			String unit = request.getParameter("unit");
			String globalRegion = request.getParameter("global_region");
			String concept = request.getParameter("concept");
			String xCoord = request.getParameter("x_coordinate");
			String yCoord = request.getParameter("y_coordinate");
			if ((serviceAddress == null) || (deviceIdString == null)
					|| (serviceName == null) || (dataString == null)
					|| (unit == null) || (dataDoubleString == null)
					|| (sensorType == null) || (globalRegion == null)
					|| (concept == null) || (dataType == null)
					|| (xCoord == null) || (yCoord == null)) {
				response.sendError(500);
				return;

			}

			try {
				double xCoordDouble = Double.parseDouble(xCoord);
				double yCoordDouble = Double.parseDouble(yCoord);
				double dataDouble = Double.parseDouble(dataDoubleString.toString());
				boolean result = Repository.add(serviceAddress, deviceIdString,
						serviceName, unit, dataDouble, dataString, sensorType,
						globalRegion, concept, dataType, xCoordDouble,
						yCoordDouble);
				if (result == true) {
					pr.print(true);
					response.setStatus(200);
				}

				else {
					pr.print(false);
					response.sendError(400);

				}

			} catch (Exception e) {
				pr.print(false);
				response.sendError(500);
			}
		}

		else if (dataType
				.equals("org.ow2.choreos.sensordata.double.celsius.temperature")
				|| dataType
						.equals("org.ow2.choreos.sensordata.double.fahrenheit.temperature")) {
			String serviceAddress = request.getParameter("address");
			String deviceIdString = request.getParameter("device_id");
			String serviceName = request.getParameter("name");
			String dataDoubleString = request.getParameter("dataDouble");
			String sensorType = request.getParameter("sensor");
			String unit = request.getParameter("unit");
			String globalRegion = request.getParameter("global_region");
			String concept = request.getParameter("concept");
			String xCoord = request.getParameter("x_coordinate");
			String yCoord = request.getParameter("y_coordinate");
			if ((serviceAddress == null) || (deviceIdString == null)
					|| (serviceName == null) || (dataString == null)
					|| (unit == null) || (dataDoubleString == null)
					|| (sensorType == null) || (globalRegion == null)
					|| (concept == null) || (dataType == null)
					|| (xCoord == null) || (yCoord == null)) {
				response.sendError(500);
				return;

			}

			try {
				double xCoordDouble = Double.parseDouble(xCoord);
				double yCoordDouble = Double.parseDouble(yCoord);
				long dataDouble = Long.parseLong(dataDoubleString.toString());
				boolean result = Repository.add(serviceAddress, deviceIdString,
						serviceName, unit, dataDouble, dataString, sensorType,
						globalRegion, concept, dataType, xCoordDouble,
						yCoordDouble);
				if (result == true) {
					pr.print(true);
					response.setStatus(200);
				}

				else {
					pr.print(false);
					response.sendError(400);

				}

			} catch (Exception e) {
				pr.print(false);
				response.sendError(500);
			}
		}

		else if (dataType.equals("org.ow2.choreos.sensordata.double.sound")) {
			String serviceAddress = request.getParameter("address");
			String deviceIdString = request.getParameter("device_id");
			String serviceName = request.getParameter("name");
			String dataDoubleString = request.getParameter("dataDouble");
			String sensorType = request.getParameter("sensor");
			String unit = request.getParameter("unit");
			String globalRegion = request.getParameter("global_region");
			String concept = request.getParameter("concept");
			String xCoord = request.getParameter("x_coordinate");
			String yCoord = request.getParameter("y_coordinate");
			if ((serviceAddress == null) || (deviceIdString == null)
					|| (serviceName == null) || (dataString == null)
					|| (unit == null) || (dataDoubleString == null)
					|| (sensorType == null) || (globalRegion == null)
					|| (concept == null) || (dataType == null)
					|| (xCoord == null) || (yCoord == null)) {
				response.sendError(500);
				return;

			}

			try {
				double xCoordDouble = Double.parseDouble(xCoord);
				double yCoordDouble = Double.parseDouble(yCoord);
				double dataDouble = Double.parseDouble(dataDoubleString.toString());
				boolean result = Repository.add(serviceAddress, deviceIdString,
						serviceName, unit, dataDouble, dataString, sensorType,
						globalRegion, concept, dataType, xCoordDouble,
						yCoordDouble);
				if (result == true) {
					pr.print(true);
					response.setStatus(200);
				}

				else {
					pr.print(false);
					response.sendError(400);

				}

			} catch (Exception e) {
				pr.print(false);
				response.sendError(500);
			}
		}
		
		else if (dataType.equals("org.ow2.choreos.sensordata.boolean")) {
			String serviceAddress = request.getParameter("address");
			String deviceIdString = request.getParameter("device_id");
			String serviceName = request.getParameter("name");
			String dataBooleanString = request.getParameter("dataBoolean");
			String sensorType = request.getParameter("sensor");
			String unit = request.getParameter("unit");
			String globalRegion = request.getParameter("global_region");
			String concept = request.getParameter("concept");
			String xCoord = request.getParameter("x_coordinate");
			String yCoord = request.getParameter("y_coordinate");
			if ((serviceAddress == null) || (deviceIdString == null)
					|| (serviceName == null) || (dataString == null)
					|| (unit == null) || (dataBooleanString == null)
					|| (sensorType == null) || (globalRegion == null)
					|| (concept == null) || (dataType == null)
					|| (xCoord == null) || (yCoord == null)) {
				response.sendError(500);
				return;

			}

			try {
				double xCoordDouble = Double.parseDouble(xCoord);
				double yCoordDouble = Double.parseDouble(yCoord);
				Boolean dataBoolean = Boolean.parseBoolean(dataBooleanString.toString());
				boolean result = Repository.add(serviceAddress, deviceIdString,
						serviceName, unit, dataBoolean, dataString, sensorType,
						globalRegion, concept, dataType, xCoordDouble,
						yCoordDouble);
				if (result == true) {
					pr.print(true);
					response.setStatus(200);
				}

				else {
					pr.print(false);
					response.sendError(400);

				}

			} catch (Exception e) {
				pr.print(false);
				response.sendError(500);
			}
		}

		else if (dataType.equals(Constants.INTEGER)) {
			String serviceAddress = request.getParameter("address");
			String deviceIdString = request.getParameter("device_id");
			String serviceName = request.getParameter("name");
			String dataIntegerString = request.getParameter("dataInteger");
			String sensorType = request.getParameter("sensor");
			String unit = request.getParameter("unit");
			String globalRegion = request.getParameter("global_region");
			String concept = request.getParameter("concept");
			String xCoord = request.getParameter("x_coordinate");
			String yCoord = request.getParameter("y_coordinate");
			if ((serviceAddress == null) || (deviceIdString == null)
					|| (serviceName == null) || (dataString == null)
					|| (unit == null) || (dataIntegerString == null)
					|| (sensorType == null) || (globalRegion == null)
					|| (concept == null) || (dataType == null)
					|| (xCoord == null) || (yCoord == null)) {
				response.sendError(500);
				return;

			}

			try {
				double xCoordDouble = Double.parseDouble(xCoord);
				double yCoordDouble = Double.parseDouble(yCoord);
				int dataInteger = Integer
						.parseInt(dataIntegerString.toString());
				boolean result = Repository.add(serviceAddress, deviceIdString,
						serviceName, unit, dataInteger, dataString, sensorType,
						globalRegion, concept, dataType, xCoordDouble,
						yCoordDouble);
				if (result == true) {
					pr.print(true);
					response.setStatus(200);
				}

				else {
					pr.print(false);
					response.sendError(400);

				}

			} catch (Exception e) {
				pr.print(false);
				response.sendError(500);
			}
		}
	}
}
