package org.ow2.choreos.registry;

// animesh -Dsun.lang.ClassLoader.allowArraySyntax=true
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.HashMap;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.simple.JSONObject;

/**
 * Servlet implementation class GetNodes
 */
public class GetNodesServlet extends HttpServlet {

    private static final long serialVersionUID = 1L;

    /**
     * @see HttpServlet#HttpServlet()
     */
    public GetNodesServlet() {
        super();
    }

    /**
     * @param request
     * @param response
     * @throws javax.servlet.ServletException
     * @throws java.io.IOException
     * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse
     * response)
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        PrintWriter pr = response.getWriter();
        response.setContentType("application/json");
        String deviceIdString = request.getParameter("device_id");
        String globalRegion = request.getParameter("global_region");
        String[] concepts = request.getParameterValues("concept");

        if ((deviceIdString == null) || (globalRegion == null)
                || (concepts == null)) {
            response.sendError(500);
            return;
        }
        try {

            //	int deviceId = Integer.parseInt(deviceIdString);
            HashMap<String, Double> result = RegistryMap.getNumberOfNodes(
                    deviceIdString, globalRegion, concepts);
            if (result != null) {

                JSONObject obj = new JSONObject();
                obj.put("value", result);

                //	System.out.println(obj);
                obj.writeJSONString(pr);
            } else {
                response.sendError(400);
            }

        } catch (IOException e) {
            System.out.println(e.getMessage());
            response.sendError(500);
        } catch (SQLException e) {
            System.out.println(e.getMessage());
            response.sendError(500);
        }
    }

}
