package org.ow2.choreos.registry;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class Registry
 */
public class KeepServiceServlet extends HttpServlet {

    /**
     * @param request
     * @param response
     * @throws javax.servlet.ServletException
     * @throws java.io.IOException
     * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse
     * response)
     */
    @Override
    protected void doPost(HttpServletRequest request,
            HttpServletResponse response) throws ServletException, IOException {
        PrintWriter pr = response.getWriter();

        String serviceAddress = request.getParameter("address");
        String period = request.getParameter("expiry_date");

        if ((serviceAddress == null) || (period == null)) {
            response.sendError(500);
            return;
        }
        try {
            long registrationExpDate = Long.parseLong(period);

            boolean result = RegistryMap.updateRegisteredService(serviceAddress, registrationExpDate);

            if (result == true) {
                pr.print(true);
                response.setStatus(200);
            } else {
                pr.print(false);
                response.sendError(400);

            }

        } catch (IOException e) {
            System.out.println(e.getMessage());
            pr.print(false);
            response.sendError(500);
        } catch (NumberFormatException e) {
            System.out.println(e.getMessage());
            pr.print(false);
            response.sendError(500);
        }
    }

}
