package org.ow2.choreos.registry;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class Registry
 */
public class RegisterServiceServlet extends HttpServlet {

    private static final long serialVersionUID = 1L;

    /**
     * Default constructor.
     */
    public RegisterServiceServlet() {
    }

    /**
     * @param request
     * @param response
     * @throws javax.servlet.ServletException
     * @throws java.io.IOException
     * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse
     * response)
     */
    @Override
    protected void doPost(HttpServletRequest request,
            HttpServletResponse response) throws ServletException, IOException {
        PrintWriter pr = response.getWriter();

        String serviceAddress = request.getParameter("address");
        String deviceIdString = request.getParameter("device_id");
        String serviceName = request.getParameter("name");
        String serviceType = request.getParameter("type");
        String accuracyString = request.getParameter("accuracy");
        String sensorType = request.getParameter("sensor");
        String rangeString = request.getParameter("range");
        String unit = request.getParameter("unit");
        String globalRegion = request.getParameter("global_region");
        String concept = request.getParameter("concept");
        String locationX = request.getParameter("coordinateX");
        String locationY = request.getParameter("coordinateY");
        String dataType = request.getParameter("dataType");
        String period = request.getParameter("expiry_date");
        String estimatedPath = request.getParameter("estimated_path");

        if ((serviceAddress == null) || (deviceIdString == null)
                || (serviceName == null) || (serviceType == null)
                || (accuracyString == null) || (sensorType == null)
                || (rangeString == null) || (globalRegion == null)
                || (concept == null) || (locationX == null)
                || (locationY == null) || (dataType == null)
                || (period == null) || (unit == null)
                || (estimatedPath == null)) {
            response.sendError(500);
            return;
        }
        try {

            // int deviceId = Integer.parseInt(deviceIdString);
            long registrationExpDate = Long.parseLong(period);
            double range = Double.parseDouble(rangeString);
            double accuracy = Double.parseDouble(accuracyString);
            double locationXDouble = Double.parseDouble(locationX);
            double locationYDouble = Double.parseDouble(locationY);

            boolean result = RegistryMap.add(serviceAddress, deviceIdString,
                    serviceName, serviceType, accuracy, sensorType, range,
                    globalRegion, concept, dataType, locationXDouble,
                    locationYDouble, registrationExpDate, unit, estimatedPath);
            if (result == true) {
                pr.print(true);
                response.setStatus(200);
            } else {
                pr.print(false);
                response.sendError(400);

            }

        } catch (IOException e) {
            System.out.println(e.getMessage());
            pr.print(false);
            response.sendError(500);
        } catch (NumberFormatException e) {
            System.out.println(e.getMessage());
            pr.print(false);
            response.sendError(500);
        } catch (SQLException e) {
            System.out.println(e.getMessage());
            pr.print(false);
            response.sendError(500);
        }
    }

}
