package org.ow2.choreos.storage;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

import org.ow2.choreos.iots.common.ServiceDescription;

public class SQLStorage {

	static String createString = "CREATE TABLE ThingsRegistry (ServiceAddress VARCHAR(100) PRIMARY KEY, "
			+ "DeviceId VARCHAR(100), ServiceName VARCHAR(100), serviceType VARCHAR(100), Accuracy DOUBLE, "
			+ "SensorType VARCHAR(100), Range DOUBLE, Region VARCHAR(20), Concept VARCHAR(20), "
			+ " DataType VARCHAR(100), LocationX Double, LocationY DOUBLE)";
	public static int totalNumberOfRows = 0;


	static String connectionURL = "jdbc:derby:Users/shachem/Desktop/DeviceRegistryManager;create=true";
	static String driver = "org.apache.derby.jdbc.EmbeddedDriver";
	static Connection conn;

	public SQLStorage( ) {
		try {
			Class.forName(driver);
		} catch (java.lang.ClassNotFoundException e) {
			System.out.println("error finding driver");
		}

		try {
			conn = DriverManager.getConnection(connectionURL);
		} catch (Throwable e) {
			System.out.println("error creating connection");
		}
		// TODO Auto-generated constructor stub
	}

	
	public static void deleteTable(String tableName){
		new SQLStorage();
		Statement s;
		String deleteString = "DROP TABLE ThingsRegistry";
		try {
			s = conn.createStatement();
			s.execute(deleteString);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
	}
	
	public static void createTable(){
		deleteTable("ThingsRegistry");
	//	new SQLStorage();
		Statement s;
		try {
			s = conn.createStatement();
			s.execute(createString);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		

	}

	public static boolean save(String serviceAddress, String deviceId,
			String serviceName, String serviceType, double accuracy,
			String sensorType, double range, String globalRegion,
			String concept, String dataType, double locationX, double locationY)
			 {
		
	/*	boolean registeredAlready = false;


		Statement selectStatement;
		try {
			selectStatement = conn.createStatement();
		} catch (SQLException e) {
			
			e.printStackTrace();
			return false;
		}
	
		String selectDevice = "SELECT * from ThingsRegistry Where ServiceAddress LIKE '"
				+ serviceAddress + "' and DeviceId LIKE '" + deviceId + "'";

		ResultSet deviceResults;
		try {
			deviceResults = selectStatement.executeQuery(selectDevice);
		} catch (SQLException e) {

			e.printStackTrace();
			return false;
		}

		try {
			while (deviceResults.next()) {
				registeredAlready = true;
			}
		} catch (SQLException e) {
		
			e.printStackTrace();
			return false;
		}
		if (registeredAlready == false) {

			PreparedStatement insertStatement;
			try {
				insertStatement = conn

				.prepareStatement("insert into ThingsRegistry(ServiceAddress, "
						+ "DeviceId, ServiceName, serviceType, Accuracy, "
						+ "SensorType, Range, Region, Concept, "
						+ " DataType, LocationX , LocationY ) " + "values ('"
						+ serviceAddress
						+ "','"
						+ deviceId
						+ "','"
						+ serviceType
						+ "','"
						+ serviceName
						+ "',"
						+ accuracy
						+ ",'"
						+ sensorType
						+ "',"
						+ range
						+ ",'"
						+ globalRegion
						+ "','"
						+ concept
						+ "','"
						+ dataType
						+ "',"
						+ locationX
						+ ","
						+ locationY
						+ ")");
			} catch (SQLException e) {
				
				e.printStackTrace();
				return false;
			}
			try {
				insertStatement.executeUpdate();
				totalNumberOfRows ++;
			} catch (SQLException e) {
				e.printStackTrace();
				return false;
			}
		}*/
		return true;

	}
	

	public static HashMap<String, Double> findNumberOfServicesReq(String deviceId,
			String globalRegion, String[] concepts) throws SQLException {
		new SQLStorage();
		createTable();

		HashMap<String, Double> NodesPerType = new HashMap<String, Double>();
		int index = -1;
		boolean checked = false;
		Statement selectStatement = conn.createStatement();
		String myConceptString = "";
		

		for (int i = 0; i < concepts.length; i++) {
			String concept = concepts[i];
			for (int j = 0; j <= i; j++) {
				if (concept.equals(concepts[j]) && i != j) {
					checked = true;
					break;
				} else
					checked = false;
			}
			if (checked == false) {
				if (i == 0)
					myConceptString = "'" + concepts[0].toString() + "'";
				else
				myConceptString = myConceptString + " OR Concept LIKE '"
						+ concepts[i] + "'";
			}
		}
		String selectDensity = "SELECT Concept, COUNT (Concept) from ThingsRegistry Where DeviceId <> '"
				+ deviceId
				+ "' and (Concept LIKE "
				+ myConceptString
				+ ") AND Region LIKE '" + globalRegion + "' Group BY Concept";
		ResultSet densityResults = selectStatement.executeQuery(selectDensity);

		while (densityResults.next()) {
			String concept = densityResults.getString(1);
			double numOfServices = densityResults.getDouble(2); // TODO
																// Auto-generated
																// method stub
			NodesPerType.put(concept, numOfServices);

			//System.out.println("densities" + NodesPerType);
		}
		return NodesPerType;
	}

	public static Set<ServiceDescription> executeLookupQueryReq(String globalRegion,
			String[] concepts) {
		new SQLStorage();
		String myConceptString = "";
		myConceptString = "'" + concepts[0].toString() + "'";
		for (int i = 0; i < concepts.length; i++) {

			myConceptString = myConceptString + " OR Concept LIKE '"
					+ concepts[i] + "'";

		}
		Set<ServiceDescription> thisSet = new HashSet();

		Statement findDevicesStatement = null;
		try {
			findDevicesStatement = conn.createStatement();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		ResultSet devicesResult = null;
		try {
			String selectServices = "SELECT * from ThingsRegistry Where (Concept LIKE "
					+ myConceptString
					+ ") AND Region LIKE '"
					+ globalRegion
					+ "'";
			devicesResult = findDevicesStatement.executeQuery(selectServices);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			while (devicesResult.next()) {
				String serviceAddress = devicesResult.getString(1);
				String deviceId = devicesResult.getString(2);
				String serviceName = devicesResult.getString(3);
				String serviceType = devicesResult.getString(4);
				Double accuracy = devicesResult.getDouble(5);
				String sensorType = devicesResult.getString(6);
				Double range = devicesResult.getDouble(7);
				String measuredConcept = devicesResult.getString(9);
				String dataType = devicesResult.getString(10);
				Double locationX = devicesResult.getDouble(11);
				Double locationY = devicesResult.getDouble(12);
				

			/*	thisSet.add(new ServiceDescription( deviceId,  serviceAddress, serviceName,
						serviceType, accuracy, globalRegion,
						range, sensorType, measuredConcept, dataType, locationX , locationY, unit));*/

				// myFoundDevicesAndServices.put(deviceId, myServicesPerDevice);

				/*
				 * System.out.println("device Id = " + deviceId +
				 * "serviceType = " + serviceType + " and device Type = " +
				 * device + " access address is " + accessAddress);
				 */
				// TODO THIS METHOD WILL QUERY THE REGISTRY

			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return thisSet;

	}

	public static boolean removeServiceReq(String serviceAddress) {
		new SQLStorage();
		String deleteDeviceQuery = "Delete from ThingsRegistry where ServiceAddress LIKE '"
				+ serviceAddress + "'";

		Statement deleteStatement = null;
		try {
			deleteStatement = conn.createStatement();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		try {
			Statement selectStatement = conn.createStatement();

			deleteStatement.executeUpdate(deleteDeviceQuery);
			totalNumberOfRows --;
			// deleteStatement.executeUpdate(deleteDeviceFromDeviceTable);

		} catch (SQLException e) {
					e.printStackTrace();
					return false;
		}
		return true;
	}

}
