package fr.inria.arles.thinglib.RESTAccess;

import java.util.concurrent.RejectedExecutionException;
import java.util.concurrent.TimeUnit;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.util.Log;
import android.widget.Toast;

public class ConnStatusBR extends BroadcastReceiver {

	private static final String TAG = "CONNSTATUSBR";

	@Override
	public void onReceive(Context c, Intent intent) {

		Log.e(TAG, "Inside BR");
		Bundle extras = intent.getExtras();

		if (extras != null
				&& intent.getAction().equals(
						ConnectivityManager.CONNECTIVITY_ACTION)) {
			Log.w(TAG, "RECEIVED CONNECTIVITY_ACTION");

			if (intent.hasExtra(ConnectivityManager.EXTRA_NETWORK_INFO)) {
				NetworkInfo netif = intent
						.getParcelableExtra(ConnectivityManager.EXTRA_NETWORK_INFO);

				if (netif.getState() == NetworkInfo.State.CONNECTED) {
					Log.w(TAG, "Connected to " + netif.getTypeName()
							+ " network.");

					if (MainActivity.ServicesWasRegistered) {

						try {
							SchedulerService.getSchedExecutor().schedule(
									new RegisterTask(), 0,
									TimeUnit.MILLISECONDS);
						} catch (RejectedExecutionException e) {
							Toast.makeText(MainActivity.AppBaseContext,
									"Exception on registering: " + e.getMessage(),
									Toast.LENGTH_LONG).show();
							Log.e(TAG, "Exception on registering: " + e.getMessage());
						}
						
					}
				}
				if (netif.getState() == NetworkInfo.State.DISCONNECTED) {

					if (MainActivity.ServicesWasRegistered) {
						Log.e(TAG, "Disconnected: Killing poll task");

						/*
						 * Cannot actually un-register here because there is no conectivity any more
						 */
						try {
							SchedulerService.getSchedExecutor().schedule(
									new UnRegisterTask(), 0, TimeUnit.MILLISECONDS);
						} catch (RejectedExecutionException e) {
							Toast.makeText(MainActivity.AppBaseContext,
									"Exception on un-registering: " + e.getMessage(),
									Toast.LENGTH_LONG).show();
							Log.e(TAG, "Exception on un-registering: " + e.getMessage());
						}
					}
				}
			}
		}
	}
}
