package fr.inria.arles.thinglib.RESTAccess;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.ThreadPoolExecutor;

import fr.inria.arles.thinglib.core.DaemonConnectionException;
import fr.inria.arles.thinglib.core.Mediator;
import fr.inria.arles.thinglib.core.MediatorListener;
import fr.inria.arles.thinglib.devices.SensorInfo;
import fr.inria.arles.thinglib.devices.SensorResponse;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;
import android.widget.Toast;

public class MediatorService extends Service {

	private static boolean enabled;
	private static MediatorService INSTANCE;
	private static final String TAG = "MediatorService";
	
	static Controller mController;
	
	
	
	private static ExecutorService exec = Executors.newSingleThreadExecutor(); 
	
	@Override
	public IBinder onBind(Intent arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void onCreate() {
		super.onCreate();
	}
	
	@Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        Log.i(TAG, "Starting "+TAG);
        INSTANCE = this;
        enabled = true;
        
        mController = new Controller(this);
        mController.startMed();
        
        return START_STICKY;
    }
	
	@Override
    public void onDestroy() {
		super.onDestroy();
		
		Log.i(TAG, "Stopping "+TAG);
		
		mController.stopMed();
		mController.stopSensing();
		mController = null;
		
		enabled = false;
		INSTANCE = null;
    }
	
	public static boolean isEnabled() {
		return enabled;
	}
	
	public static MediatorService getInstance() {
		return INSTANCE;
	}
	
	public static Controller getController() {
		return mController;
	}
	
}
