package fr.inria.arles.thinglib.RESTAccess;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;

import org.ow2.choreos.iots.common.Constants;
import org.ow2.choreos.iots.common.Location;
import org.ow2.choreos.choreosiotsmanager.impl.ThingsRegistrationManagerImpl;

import android.util.Log;

public class RegisterTask implements Runnable {

	private static final String TAG = "RegisterTask";
	
	@Override
	public void run() {
		ThingsRegistrationManagerImpl cm = new ThingsRegistrationManagerImpl();
		try {
			ArrayList<Location> path = new ArrayList<Location>();
			Long timeNow = new Date().getTime();
			path.add(new Location( MainActivity.myLocation.getLatitude(), MainActivity.myLocation.getLongitude(),timeNow ));
			path.add(new Location( MainActivity.myLocation.getLatitude() + 0.001, MainActivity.myLocation.getLongitude()+ 0.001,timeNow + 500));
			path.add(new Location( MainActivity.myLocation.getLatitude() + 0.002, MainActivity.myLocation.getLongitude()+ 0.004,timeNow + 1500));
			path.add(new Location( MainActivity.myLocation.getLatitude() + 0.005, MainActivity.myLocation.getLongitude()+ 0.002,timeNow + 2500));
			path.add(new Location( MainActivity.myLocation.getLatitude() + 0.004, MainActivity.myLocation.getLongitude()+ 0.001,timeNow + 3500));
			
			
			boolean noiseRegistered = cm.executeRegistrationQuery(MainActivity.UNIQUE_ID, "getnoiselevel", 
					"noiselevel_service", 0.95, "noiselevel_sensor", "noiselevel",1.0, 1.0, 
					Static_Addresses.PROXY_URL + MainActivity.UNIQUE_ID+"/getnoiselevel", 
					Constants.DOUBLENOISE, MainActivity.myLocation.getLatitude(), MainActivity.myLocation.getLongitude(), path,"db");
			
			boolean locationRegistered = cm.executeRegistrationQuery(MainActivity.UNIQUE_ID, "getlocation", "location_service", 0.95, 
					"location_sensor", "location",1.0, 1, Static_Addresses.PROXY_URL + MainActivity.UNIQUE_ID+"/getlocation", 
					Constants.DOUBLE2DLOCATION, MainActivity.myLocation.getLatitude(), MainActivity.myLocation.getLongitude(),path,"");
			
			boolean pushMessageRegistered = cm.executeRegistrationQuery(MainActivity.UNIQUE_ID, "message", "push_service", 0.95, 
					"no_physical_sensor", "messaging",1.0, 1, Static_Addresses.PROXY_URL + MainActivity.UNIQUE_ID+"/pushmessage", 
					Constants.DOUBLE2DLOCATION, MainActivity.myLocation.getLatitude(), MainActivity.myLocation.getLongitude(),path,"");
			
			/*
			 * FEATURE:
			 * Distinguish taxis and users for VTRIP dynaroute
			 */
			boolean userTypeLocationRegistered = cm.executeRegistrationQuery(MainActivity.UNIQUE_ID, "getlocation", "location_service", 0.95, 
					"location_sensor", MainActivity.user_type + "_location",1.0, 1, Static_Addresses.PROXY_URL + MainActivity.UNIQUE_ID+"/getlocation", 
					Constants.DOUBLE2DLOCATION, MainActivity.myLocation.getLatitude(), MainActivity.myLocation.getLongitude(),path,"");
			
		Log.i(TAG, "Registering noise service...: " + noiseRegistered);
		Log.i(TAG, "Registering location service...: " + locationRegistered);
		Log.i(TAG, "Registering push message service...: " + pushMessageRegistered);
		Log.i(TAG, "Registering user type location service...: " + userTypeLocationRegistered);

        MainActivity.stopRingDialog();

		} catch(IOException e) {
			Log.e(TAG, "Exception thrown during registration: "+e.toString());
		}
	}

}
