
//
//  MainActivity lass
//  SensorAccess
//
//  Created by Georgios Mathioudakis (georgios.mathioudakis@inria.fr) on 4/2/2014
//  Copyright (c) 2014 fr.inria.arles. All rights reserved.
//
//  Description: Scheduler Service is the Android Service handling all asynchronous calls and responses to the Registry and Proxy
//
package fr.inria.arles.thinglib.RESTAccess;

import java.util.concurrent.ScheduledThreadPoolExecutor;
import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;

public class SchedulerService extends Service {

	private static SchedulerService INSTANCE;
	private static final String TAG = "SchedulerService";
    private static ScheduledThreadPoolExecutor sched = null;
	static long POLL_DELAY_MILLISEC = 1300;
	
	@Override
	public IBinder onBind(Intent arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void onCreate() {
		super.onCreate();		
	}
	
	@Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        Log.i(TAG, "Starting "+TAG);
        INSTANCE = this;

        return START_STICKY;
    }
	
	@Override
    public void onDestroy() {
		super.onDestroy();
		Log.i(TAG, "Stopping "+TAG);

        INSTANCE = null;
    }
	
	public static SchedulerService getInstance() {
		return INSTANCE;
	}
	
	public static ScheduledThreadPoolExecutor getSchedExecutor() {
		return sched;
	}
	
	/**
	 * Use this method to create an instance of ScheduledThreadPoolExecutor if there is no one yet
	 */
	public static void CreateNewThreadPoolExecutor(){
		if(sched == null)
			sched = new ScheduledThreadPoolExecutor(1);
	}
	
	/**
	 * Use this method to destroy the instance of ScheduledThreadPoolExecutor
	 */
	public static void DestroyThreadPoolExecutor(){
		sched = null;
	}
}
