/**
 * ****************************************************************
 * Author: Georgios Mathioudakis (georgios.mathioudakis@inria.fr) Project:
 * ServiceUI package: fr.inria.arles.android.serviceui Created: 15 juil. 2013
 * Updated: Status: Description:
 * ****************************************************************
 */
package fr.inria.arles.thinglib.RESTAccess;

import fr.inria.arles.thinglib.R;
import android.content.SharedPreferences;
import android.content.SharedPreferences.OnSharedPreferenceChangeListener;
import android.os.Bundle;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;
import android.util.Log;
import android.widget.TextView;

public class SettingsActivity extends PreferenceActivity implements
        OnSharedPreferenceChangeListener {

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        addPreferencesFromResource(R.xml.main_preferences);
    }

    @Override
    public void onSharedPreferenceChanged(SharedPreferences sharedPreferences,
            String key) {
        String Registry_Host = "";
        String Proxy_Host = "";
        try {
            if (sharedPreferences.contains("RegistryIP")) {
                Registry_Host = (String) sharedPreferences.getString(
                        "RegistryIP", Static_Addresses.REGISTRY_HOST);
                Static_Addresses.Set_RegistryHost(Registry_Host);
            }
            if (sharedPreferences.contains("ProxyIP")) {
                Proxy_Host = (String) sharedPreferences.getString("ProxyIP",
                        Static_Addresses.PROXY_HOST);
                Static_Addresses.Set_ProxyHost(Proxy_Host);
            }
            if (sharedPreferences.contains("WebsocketActive")) {
                boolean WebSocket_Switch = sharedPreferences.getBoolean(
                        "WebsocketActive", false);
                MainActivity.WebSocket_Switch = WebSocket_Switch;
            }
            if (sharedPreferences.contains("userTypeSelection")) {
                MainActivity.user_type = (String) sharedPreferences.getString("userTypeSelection", "user");
            }
        } catch (ClassCastException e) {
            Log.d("SETTINGS", e.getMessage());
        }
    }

    @Override
    protected void onResume() {
        super.onResume();
//        getPreferenceScreen().getSharedPreferences().registerOnSharedPreferenceChangeListener(this);
//        getPreferenceScreen().findPreference("ProxyIP").setDefaultValue(Static_Addresses.PROXY_HOST + "");
//        getPreferenceScreen().findPreference("RegistryIP").setDefaultValue(Static_Addresses.REGISTRY_HOST + "");
//        if (MainActivity.SensorsEnabled == true) {
//            getPreferenceScreen().findPreference("WebsocketActive").setEnabled(
//                    false);
//        } else {
//            getPreferenceScreen().findPreference("WebsocketActive").setEnabled(
//                    true);
//        }
    }

    @Override
    protected void onPause() {
        super.onPause();
        getPreferenceScreen().getSharedPreferences()
                .unregisterOnSharedPreferenceChangeListener(this);
    }
}
