package fr.inria.arles.thinglib.RESTAccess;

import java.io.IOException;

import org.ow2.choreos.iots.common.Constants;
import org.ow2.choreos.choreosiotsmanager.impl.ThingsRegistrationManagerImpl;

import android.util.Log;

public class UnRegisterTask implements Runnable {

	private static final String TAG = "RegisterTask";

	@Override
	public void run() {
		ThingsRegistrationManagerImpl cm = new ThingsRegistrationManagerImpl();
		try {
			boolean noiseRegistered = cm.executeUnRegistrationQuery(
					MainActivity.UNIQUE_ID, "getnoiselevel",
					"noiselevel_service", 0.95, "noiselevel_sensor",
					"noiselevel", 1.0, 0.9, Static_Addresses.PROXY_URL
							+ MainActivity.UNIQUE_ID + "/getnoiselevel",
					Constants.DOUBLENOISE, 0, 0, "db");

			boolean locationRegistered = cm.executeUnRegistrationQuery(
					MainActivity.UNIQUE_ID, "getlocation", "location_service",
					0.95, "location_sensor", "location", 1.0, 1,
					Static_Addresses.PROXY_URL + MainActivity.UNIQUE_ID
							+ "/getlocation", Constants.DOUBLE2DLOCATION, 0, 0,
					"");

			boolean messagingRegistered = cm.executeUnRegistrationQuery(
					MainActivity.UNIQUE_ID, "message", "push_service", 0.95,
					"no_physical_sensor", "messaging", 1.0, 1,
					Static_Addresses.PROXY_URL + MainActivity.UNIQUE_ID
							+ "/pushmessage", Constants.DOUBLE2DLOCATION,
					MainActivity.myLocation.getLatitude(),
					MainActivity.myLocation.getLongitude(), "");

			/*
			 * User type location for VTRIP demo
			 */
			boolean userTypeLocationRegistered = cm.executeUnRegistrationQuery(
					MainActivity.UNIQUE_ID, "getlocation", "location_service", 0.95,
					"no_physical_sensor", MainActivity.user_type + "_location",
					1.0, 1, Static_Addresses.PROXY_URL + MainActivity.UNIQUE_ID
							+ "/getlocation", Constants.DOUBLE2DLOCATION,
					MainActivity.myLocation.getLatitude(),
					MainActivity.myLocation.getLongitude(), "");

			Log.i(TAG, "Un-Registering noise service...: " + noiseRegistered);
			Log.i(TAG, "Un-Registering location service...: "
					+ locationRegistered);
			Log.i(TAG, "Un-Registering messaging service...: "
					+ messagingRegistered);
			Log.i(TAG, "Un-Registering user type location service...: "
					+ userTypeLocationRegistered);
		} catch (IOException e) {
			Log.e(TAG, "Exception thrown during registration: " + e.toString());
		}
	}

}
