package fr.inria.arles.thinglib.RESTAccess;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import android.util.Log;

public class UpdateLocationToRegistry implements Runnable {

	private static final String TAG = "UpdateLocationToRegistry";

	@Override
	public void run() {
		HttpClient client = new DefaultHttpClient();
		String uri = Static_Addresses.REGISTRY_URL + "updatedevice";

		HttpPost httpPost = new HttpPost(uri);
		try {
			List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(1);
			nameValuePairs.add(new BasicNameValuePair("deviceID",
					MainActivity.UNIQUE_ID));
			nameValuePairs.add(new BasicNameValuePair("location_x",
					MainActivity.myLocation.getLatitude() + ""));
			nameValuePairs.add(new BasicNameValuePair("location_y",
					MainActivity.myLocation.getLongitude() + ""));
			httpPost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
		} catch (UnsupportedEncodingException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		try {
			HttpResponse response = client.execute(httpPost);
			StatusLine statusLine = response.getStatusLine();
			int statusCode = statusLine.getStatusCode();
			if (statusCode == 200) {
				Log.i(TAG, "Updating location to Registry: SUCCESS");
			}
		} catch (ClientProtocolException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
