package fr.inria.arles.thinglib.core;

import java.io.IOException;

/**
 * Describes an exception that occurs when a sensor that already exists in the
 * Mediator is re-added to it. Instead of allowing the duplication of
 * sensors, the Mediator returns this exception.
 */
public class DuplicateDeviceException extends IOException {

	private static final long serialVersionUID = -3901760224438757774L;

	public DuplicateDeviceException() {
		this(null);
	}

	public DuplicateDeviceException(String message) {
		super(message);
	}
}

