package fr.inria.arles.thinglib.core;

import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;

/**
 * Usage: 
 *
 * SimpleLatch myLatch = new SimpleLatch();
 * 
 * (...)
 * 
 * myLatch.grab();
 * startNewThread(); // this calls myLatch.free() at some point
 * myLatch.await(1000);
 * 
 * (...) 
 */
public class SimpleLatch {

	protected boolean mLatched = true;
	protected CountDownLatch mCountdownLatch; 
	
	public void grab() {
		//mLatched = true;
		mCountdownLatch = new CountDownLatch(1);
	}

	public void release() {		
		//mLatched = false;
		//this.notify();
		mCountdownLatch.countDown();
	}

	public synchronized boolean await(long timeout) {
		try {
			return mCountdownLatch.await(timeout, TimeUnit.MILLISECONDS);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		}
		/*
		while (mLatched) {
			try {
				this.wait(timeout);
			} catch (InterruptedException e) {
				// do nothing!
			}
		}
		*/
	}
};

