package fr.inria.arles.thinglib.datatypes;

public class DefaultDouble3dData extends Double3dData {

	private static final long serialVersionUID = 8205724392915403983L;
	protected static final String UID = "fr.inria.arles.sensordata.3d-double";
	protected static final String INTERFACE = "fr.inria.arles.sensordata.3d-double";

	public DefaultDouble3dData(double x, double y, double z, long t) {
		super(x, y, z, t);
	}

	@Override
	public SensorData fromStringArray(String[] sa) {
		return (SensorData) (new DefaultDouble3dData(Double.parseDouble(sa[0]), 
				Double.parseDouble(sa[1]), Double.parseDouble(sa[2]), 
				Long.parseLong(sa[3])));
	}

	@Override
	public String[] toStringArray() {
		String[] s = new String[4];
		s[0] = Long.toString(timestamp);
		s[1] = Double.toString(x);
		s[2] = Double.toString(y);
		s[3] = Double.toString(z);
		return s;
	}

	@Override
	public String[] getComponentNames() {
		String[] s = new String[4];
		s[0] = "timestamp";
		s[1] = "x";
		s[2] = "y";
		s[3] = "z";
		return s;
	}

	@Override
	public boolean isFresh() {
		return true;
	}

	@Override
	public String toString() {
		return  "x:" + Double.toString(x) +
		       " y:" + Double.toString(y) +
		       " z:" + Double.toString(z) +
		       " timestamp:" + Long.toString(timestamp);
	}
	
	@Override
	public SensorData copy() {
		// since this class is immutable, just return the current instance
		return this;
	}
	
	@Override
	public String getUid() {
		return UID;
	}
	
	@Override
	public String getInterface() {
		return INTERFACE;
	}
}


