package fr.inria.arles.thinglib.datatypes;

public class DefaultDouble4dData extends Double4dData {

	private static final long serialVersionUID = 8205724391911403913L;
	protected static final String UID = "fr.inria.arles.sensordata.4d-double";
	protected static final String INTERFACE = "fr.inria.arles.sensordata.4d-double";

	public DefaultDouble4dData(double x, double y, double z, double w, long t) {
		super(x, y, z, w, t);
	}

	@Override
	public SensorData fromStringArray(String[] sa) {
		return (SensorData) (new DefaultDouble4dData(Double.parseDouble(sa[0]), 
				Double.parseDouble(sa[1]), Double.parseDouble(sa[2]),
				Double.parseDouble(sa[3]), Long.parseLong(sa[4])));
	}

	@Override
	public String[] toStringArray() {
		String[] s = new String[5];
		s[0] = Long.toString(timestamp);
		s[1] = Double.toString(x);
		s[2] = Double.toString(y);
		s[3] = Double.toString(z);
		s[4] = Double.toString(w);
		return s;
	}

	@Override
	public String[] getComponentNames() {
		String[] s = new String[5];
		s[0] = "timestamp";
		s[1] = "x";
		s[2] = "y";
		s[3] = "z";
		s[4] = "w";
		return s;
	}

	@Override
	public boolean isFresh() {
		return true;
	}

	@Override
	public String toString() {
		return  "x:" + Double.toString(x) +
		       " y:" + Double.toString(y) +
		       " z:" + Double.toString(z) +
		       " w:" + Double.toString(w) +
		       " timestamp:" + Long.toString(timestamp);
	}
	
	@Override
	public SensorData copy() {
		// since this class is immutable, just return the current instance
		return this;
	}
	
	@Override
	public String getUid() {
		return UID;
	}
	
	@Override
	public String getInterface() {
		return INTERFACE;
	}
}

