package fr.inria.arles.thinglib.datatypes;

public class DefaultDouble4dLocationData extends DefaultDouble4dData {

	private static final long serialVersionUID = -127441348591121355L;
	protected static final String UID = "org.ow2.choreos.sensordata.4d-double.location";
	protected static final String INTERFACE = "org.ow2.choreos..sensordata.4d-double.location";

	public DefaultDouble4dLocationData(double latitude, double longitude, double speed, 
			double direction, long timestamp) {
		super(latitude, longitude, speed, direction, timestamp);
	}

	@Override
	public SensorData fromStringArray(String[] sa) {
		return (SensorData) (new DefaultDouble4dLocationData(Double.parseDouble(sa[0]), 
				Double.parseDouble(sa[1]), Double.parseDouble(sa[2]),
				Double.parseDouble(sa[3]), Long.parseLong(sa[4])));
	}

	@Override
	public String[] getComponentNames() {
		String[] s = new String[3];
		s[0] = "latitude";
		s[1] = "longitude";
		s[2] = "speed";
		s[3] = "direction";
		s[4] = "timestamp";
		return s;
	}
	
	@Override
	public String getUid() {
		return UID;
	}
	
	public double getLatitude() {
		return super.getX();
	}
	
	public double getLongitude() {
		return super.getY();
	}
	
	public double getSpeed() {
		return super.getZ();
	}
	
	public double getDirection() {
		return super.getW();
	}
}
