package fr.inria.arles.thinglib.datatypes;

public abstract class Double2dData extends SensorData {

	private static final long serialVersionUID = 5508555229342582371L;
	
	protected final double x;
	protected final double y;
	
	public Double2dData(double x, double y, long t) {
		super(t);
		this.x = x;
		this.y = y;
	}

	public double getX() {
		return x;
	}

	public double getY() {
		return y;
	}

	@Override
	public String toString() {
		return  "x:" + Double.toString(x) +
		       " y:" + Double.toString(y) +
		       " timestamp:" + Long.toString(timestamp);
	}
	
	@Override
	public String[] toStringArray() {
		String[] s = new String[3];
		s[0] = Double.toString(x);
		s[1] = Double.toString(y);
		s[2] = Long.toString(timestamp);
		return s;
	}
}


