package fr.inria.arles.thinglib.datatypes;

public abstract class Double4dData extends SensorData {

	private static final long serialVersionUID = 8205524332915403983L;

	protected final double x;
	protected final double y;
	protected final double z;
	protected final double w;
	
	public Double4dData(double x, double y, double z, double w, long t) {
		super(t);
		this.x = x;
		this.y = y;
		this.z = z;
		this.w = w;
	}

	public double getX() {
		return x;
	}

	public double getZ() {
		return z;
	}

	public double getY() {
		return y;
	}
	
	public double getW() {
		return w;
	}

	@Override
	public String toString() {
		return  "x:" + Double.toString(x) +
		       " y:" + Double.toString(y) +
		       " z:" + Double.toString(z) +
		       " w:" + Double.toString(w) +
		       " timestamp:" + Long.toString(timestamp);
	}
	
	@Override
	public String[] toStringArray() {
		String[] s = new String[5];
		s[0] = Long.toString(timestamp);
		s[1] = Double.toString(x);
		s[2] = Double.toString(y);
		s[3] = Double.toString(z);
		s[4] = Double.toString(w);
		return s;
	}
}


