package fr.inria.arles.thinglib.datatypes;

public abstract class DoubleData extends SensorData {

	private static final long serialVersionUID = 6927592376981831812L;

	protected final double value;

	public DoubleData(double value, long timestamp) {
		super(timestamp);
		this.value = value;
	}

	public double getValue() {
		return value;
	}

	@Override
	public String toString() {
		return Double.toString(value);
	}

	@Override
	public String[] toStringArray() {
		String[] s = new String[2];
		s[0] = Long.toString(timestamp);
		s[1] = Double.toString(value);
		return s;
	}
}

