package fr.inria.arles.thinglib.datatypes;

public abstract class IntegerData extends SensorData {

	private static final long serialVersionUID = -6067451962406761846L;

	protected final int value;

	public IntegerData(int value, long timestamp) {
		super(timestamp);
		this.value = value;
	}

	public int getValue() {
		return value;
	}

	@Override
	public String toString() {
		return Integer.toString(value);
	}

	@Override
	public String[] toStringArray() {
		String[] s = new String[2];
		s[0] = Long.toString(timestamp);
		s[1] = Integer.toString(value);
		return s;
	}
}

