package fr.inria.arles.thinglib.devices;

import fr.inria.arles.thinglib.platforms.OuterScopeWrapper;

public class DummySensorInfo extends SensorInfo {

	private static final long serialVersionUID = 5185816732830319152L;
	
	protected final String UID         = "fr.inria.arles.sensor.dummysensor";
	protected final String INTERFACE   = "fr.inria.arles.sensor.counter";

	protected final String LONG_NAME   = "Dummy counting sensor";
	protected final String SHORT_NAME  = "Counter";
	protected final String DESCRIPTION = "Simply counts up from 0 to 2^31 - 1.";

	protected final String AUTHOR      = "INRIA Arles";
	protected final String DOC_URL     = null;

	@Override public String getUid()              { return UID;         } 
	@Override public String getInterface()        { return INTERFACE;   } 
	@Override public String getLongName()         { return LONG_NAME;   } 
	@Override public String getShortName()        { return SHORT_NAME;  } 
	@Override public String getDescription()      { return DESCRIPTION; } 
	@Override public String getAuthor()           { return AUTHOR;      } 
	@Override public String getDocumentationUrl() { return DOC_URL;     } 
	@Override public boolean isEventBased()       { return false;       }

	@Override
	public Sensor getSensorInstance(OuterScopeWrapper outerScope) {
		return new DummySensor(this);
	}
}

