package fr.inria.arles.thinglib.devices;

/**
 * This class contains metadata about an interval sensor.
 */
public abstract class IntervalSensorInfo extends SensorInfo {

	private static final long serialVersionUID = 4603241141866000878L;

	/**
	 * Required. The preferred sensing period for this sensor.
	 */
	public static final long preferredSensingPeriod = -1; 

	/**
	 * Required. The preferred number of samples for this sensor.
	 */
	public static final int preferredNumberOfSamples = -1;


	// [Thiago] I removed the member below as there are still some issues with
	// how the sensing periods should be exposed. Therefore, since we will not
	// be using this feature anytime soon anyways, I decided to postpone
	// implementing it.
	//
	// /**
	//  * Required. An array of valid sensing periods to be presented to the user.
	//  */
	// public final long[] validSensingPeriods; 
}

