package fr.inria.arles.thinglib.devices.android;

import android.os.Parcel;

/**
 * This class contains metadata that is common to all inertial sensors.
 */
public abstract class InertialSensorInfo extends ParcelableSensorInfo {

	private static final long serialVersionUID = 4727344531458121005L;
	
	public static final String AUTHOR  = "INRIA Arles";
	public static final String DOC_URL = null;

	/**
	 * The preferred sensing period for this sensor.
	 */
	public static final long preferredSensingPeriod  = 100;

	/**
	 * The preferred number of samples for this sensor.
	 */
	public static final int preferredNumberOfSamples = 1;
	
	
	protected InertialSensorInfo() {}


	/* Android parcelable-related methods */

	@Override
	public int describeContents() {
		return 0;
	}

	@Override public void writeToParcel(Parcel out, int flags) {}
	protected InertialSensorInfo(Parcel in) {}
}

