package fr.inria.arles.thinglib.devices.android;

import android.os.Parcel;
import android.os.Parcelable;
import fr.inria.arles.thinglib.devices.Sensor;
import fr.inria.arles.thinglib.platforms.OuterScopeWrapper;

/**
 * This class contains metadata about the orientation sensor.
 */
public class LocationSensorInfo extends ParcelableSensorInfo {

	private static final long serialVersionUID = 7153832198529967859L;
	
	protected final String UID         = "fr.inria.arles.sensor.location";
	protected final String INTERFACE   = "fr.inria.arles.sensor.location";

	protected final String LONG_NAME   = "Location sensor";
	protected final String SHORT_NAME  = "Location sensor";
	protected final String DESCRIPTION = "";

	protected final String AUTHOR = "INRIA Arles";
	protected final String DOC_URL = null;

	protected static LocationSensor sSingleton;

	@Override
	public Sensor getSensorInstance(OuterScopeWrapper scope) {
		if (sSingleton == null) sSingleton = new LocationSensor(scope, this);
		return sSingleton;
	}

	@Override public String getUid()              { return UID;         } 
	@Override public String getInterface()        { return INTERFACE;   } 
	@Override public String getLongName()         { return LONG_NAME;   } 
	@Override public String getShortName()        { return SHORT_NAME;  } 
	@Override public String getDescription()      { return DESCRIPTION; } 
	@Override public String getAuthor()           { return AUTHOR;      } 
	@Override public String getDocumentationUrl() { return DOC_URL;     } 
	@Override public boolean isEventBased()       { return false;       }

	protected LocationSensorInfo() {}


	/* Android parcelable-related methods */

	@Override
	public int describeContents() {
		return 0;
	}

	@Override public void writeToParcel(Parcel out, int flags) {}

	public static final Parcelable.Creator<LocationSensorInfo> CREATOR = 
		new Parcelable.Creator<LocationSensorInfo>() {

		public LocationSensorInfo createFromParcel(Parcel in) {
			return new LocationSensorInfo(in);
		}

		public LocationSensorInfo[] newArray(int size) {
			return new LocationSensorInfo[size];
		}
	};

	private LocationSensorInfo(Parcel in) {}
}


