package fr.inria.arles.thinglib.devices.android;

import java.io.IOException;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;

import fr.inria.arles.thinglib.core.Messaging;
import fr.inria.arles.thinglib.devices.SensorInfo;

public abstract class SensorService extends Service {

	public abstract SensorInfo getSensorInfo();

	private final SensorAidlInterface.Stub mBinder = new SensorAidlInterface.Stub() {

		@Override
		public byte[] getSensorInfo() {
			try {
				return Messaging.toBytes(SensorService.this.getSensorInfo());
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}
	};

	@Override
	public IBinder onBind(Intent intent) {
		return mBinder;
	}
	
	@Override 
	public boolean onUnbind(Intent intent) {
		return super.onUnbind(intent);
	}
}
