package fr.inria.arles.thinglib.platforms;

/**
 * A small wrapper around an arbitrary Object. At the moment, this is not
 * different from passing an Object around, but in the future there may be some
 * extra logic in here if needed.
 */
public class OuterScopeWrapper {

	/**
	 * The wrapped Object.
	 */
	protected final Object mObj;

	/**
	 * Constructor. Creates a new OuterScopeWrapper by storing the given
	 * Object.
	 * @param obj The object to wrap within this instance
	 */
	public OuterScopeWrapper(Object obj) {
		mObj = obj;
	}

	/**
	 * Gets the object that was stored of this OuterScopeWrapper.
	 * @return The object wrapped in this instance
	 */
	public Object getContents() {
		return mObj;
	}
	
}

