package fr.inria.arles.thinglib.platforms.android;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.widget.Toast;

public class DaemonService extends Service {

	protected final fr.inria.arles.thinglib.platforms.android.Daemon mDaemon;

	private boolean started = false;
	
	private int bindClientCount;
	
	public DaemonService() {
		mDaemon = new fr.inria.arles.thinglib.platforms.android.Daemon(this);
		bindClientCount = 0;
	}
/*
	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		
		if(!started) {
			// NOTE: we discover the sensors here because if we leave it to take
			// place during the REGISTER_CLIENT phase Android actually doesn't do
			// it properly. For some reason, if we do that the bindService() 
			// method does not end up binding the sensors :/
			mDaemon.discoverSensors();
			
			showNotification("Sensor daemon started.");
		}
		started = true;
		
		return startId;
	}
*/
	@Override
	public void onDestroy() {
		showNotification("Sensor daemon stopped.");
		
	}

	/**
	 * When binding to the service, we return an interface to our messenger
	 * for sending messages to the service.
	 */
	@Override
	public IBinder onBind(Intent intent) {
		bindClientCount++;
		showNotification("Bound to Sensor Daemon. Count :"+bindClientCount);
		
		if(bindClientCount == 1)
			mDaemon.discoverSensors();
			
		return mDaemon.getBinder();
	}

	@Override
	public boolean onUnbind(Intent intent) {
		bindClientCount--;
		
		if(bindClientCount == 0)
			mDaemon.kill();
		
		return false;
	};
	
	/**
	 * Show a notification while this service is running.
	 */
	protected void showNotification(String text) {

		int duration = Toast.LENGTH_SHORT;
		Toast toast = Toast.makeText(this, text, duration);
		toast.show();
	}
}

