package org.ow2.choreos.iots.common;

import org.json.simple.JSONObject;

public class DataDescription
{
  private static final String DATASTRING = "dataString";
  private static final String ADDRESS = "address";
  private static final String NAME = "name";
  private static final String DEVICEID = "DeviceId";
  private static final String DATADOUBLE = "dataDouble";
  private static final String DATABOOLEAN = "dataBoolean";
  private static final String DATADOUBLE1 = "dataDouble1";
  private static final String DATADOUBLE2 = "dataDouble2";
  private static final String GLOBALREGION = "global_region";
  private static final String UNIT = "unit";
  private static final String SENSOR = "sensor";
  private static final String CONCEPT = "concept";
  private static final String DATATYPE = "dataType";
  private static final String XCOORDINATE = "xCoordinate";
  private static final String YCOORDINATE = "yCoordinate";
  String deviceID;
  String address;
  String name;
  double myDataDouble;
  double myDataDouble1;
  double myDataDouble2;
  double myDataDouble3;
  Long myDataLong;
  Integer myDataInteger;
  String unit;
  String globalRegion;
  String dataString;
  String sensor;
  String concept;
  String dataType;
  double xCoordinate;
  double yCoordinate;
  boolean myDataBoolean;

  private DataDescription()
  {
  }

  public DataDescription(String deviceID, String address, String name, String dataString, double dataDouble, String globalRegion, String unit, String sensor, String concept, String dataType, double xCoordinate, double yCoordinate)
  {
    this.deviceID = deviceID;
    this.address = address;
    this.name = name;
    this.myDataDouble = dataDouble;
    this.dataString = dataString;
    this.globalRegion = globalRegion;
    this.unit = unit;
    this.sensor = sensor;
    this.concept = concept;
    this.dataType = dataType;
    this.xCoordinate = xCoordinate;
    this.yCoordinate = yCoordinate;
  }

  public DataDescription(String deviceID, String address, String name, String dataString, boolean dataBoolean, String globalRegion, String unit, String sensor, String concept, String dataType, double xCoordinate, double yCoordinate)
  {
    this.deviceID = deviceID;
    this.address = address;
    this.name = name;
    this.myDataBoolean = dataBoolean;
    this.dataString = dataString;
    this.globalRegion = globalRegion;
    this.unit = unit;
    this.sensor = sensor;
    this.concept = concept;
    this.dataType = dataType;
    this.xCoordinate = xCoordinate;
    this.yCoordinate = yCoordinate;
  }

  public DataDescription(String deviceID, String address, String name, String dataString, double dataDouble1, double dataDouble2, String globalRegion, String unit, String sensor, String concept, String dataType, double xCoordinate, double yCoordinate)
  {
    this.deviceID = deviceID;
    this.address = address;
    this.name = name;
    this.myDataDouble1 = dataDouble1;
    this.myDataDouble2 = dataDouble2;
    this.dataString = dataString;
    this.globalRegion = globalRegion;
    this.unit = unit;
    this.sensor = sensor;
    this.concept = concept;
    this.dataType = dataType;
    this.xCoordinate = xCoordinate;
    this.yCoordinate = yCoordinate;
  }

  public DataDescription(String deviceID, String address, String name, String dataString, double dataDouble1, double dataDouble2, double dataDouble3, String globalRegion, String unit, String sensor, String concept, String dataType, double xCoordinate, double yCoordinate)
  {
    this.deviceID = deviceID;
    this.address = address;
    this.name = name;
    this.myDataDouble1 = dataDouble1;
    this.myDataDouble2 = dataDouble2;
    this.myDataDouble3 = dataDouble3;
    this.dataString = dataString;
    this.globalRegion = globalRegion;
    this.unit = unit;
    this.sensor = sensor;
    this.concept = concept;
    this.dataType = dataType;
    this.xCoordinate = xCoordinate;
    this.yCoordinate = yCoordinate;
  }

  public DataDescription(String deviceID, String address, String name, String dataString, long dataLong, String globalRegion, String unit, String sensor, String concept, String dataType, double xCoordinate, double yCoordinate)
  {
    this.deviceID = deviceID;
    this.address = address;
    this.name = name;
    this.myDataLong = Long.valueOf(dataLong);
    this.dataString = dataString;
    this.globalRegion = globalRegion;
    this.unit = unit;
    this.sensor = sensor;
    this.concept = concept;
    this.dataType = dataType;
    this.xCoordinate = xCoordinate;
    this.yCoordinate = yCoordinate;
  }

  public DataDescription(String deviceID, String address, String name, String dataString, int dataInteger, String globalRegion, String unit, String sensor, String concept, String dataType, double xCoordinate, double yCoordinate)
  {
    this.deviceID = deviceID;
    this.address = address;
    this.name = name;
    this.myDataInteger = Integer.valueOf(dataInteger);
    this.dataString = dataString;
    this.globalRegion = globalRegion;
    this.unit = unit;
    this.sensor = sensor;
    this.concept = concept;
    this.dataType = dataType;
    this.xCoordinate = xCoordinate;
    this.yCoordinate = yCoordinate;
  }

  public String getDeviceID() {
    return this.deviceID;
  }

  public String getDataType() {
    return this.dataType;
  }

  public double getDataDouble1() {
    return this.myDataDouble1;
  }

  public double getDataDouble2() {
    return this.myDataDouble2;
  }

  public double getDataDouble3() {
    return this.myDataDouble3;
  }

  public long getDataLong() {
    return this.myDataLong.longValue();
  }

  public int getDataInteger() {
    return this.myDataInteger.intValue();
  }

  public String getAddress() {
    return this.address;
  }

  public String getName() {
    return this.name;
  }

  public String getUnit() {
    return this.unit;
  }

  public double getdataDouble() {
    return this.myDataDouble;
  }

  public boolean getdataBoolean() {
    return this.myDataBoolean;
  }

  public String getGlobalRegion() {
    return this.globalRegion;
  }

  public String getDataString() {
    return this.dataString;
  }

  public String getSensor() {
    return this.sensor;
  }

  public String getConcept() {
    return this.concept;
  }

  public double getXCoord() {
    return this.xCoordinate;
  }

  public double getYCoord() {
    return this.yCoordinate;
  }

  public JSONObject serializeAsJSON() {
    JSONObject ret = new JSONObject();
    ret.put("address", this.address);
    ret.put("name", this.name);
    ret.put("concept", this.concept);
    ret.put("DeviceId", this.deviceID);
    ret.put("global_region", this.globalRegion);
    ret.put("dataString", this.dataString);
    ret.put("unit", this.unit);
    ret.put("sensor", this.sensor);
    ret.put("dataType", this.dataType);
    ret.put("xCoordinate", Double.valueOf(this.xCoordinate));
    ret.put("yCoordinate", Double.valueOf(this.yCoordinate));
    if (this.dataType.equals(Constants.DOUBLE2DLOCATION)) {
      ret.put("dataDouble1", Double.valueOf(this.myDataDouble1));
      ret.put("dataDouble2", Double.valueOf(this.myDataDouble2));
    } else if ((this.dataType.equals(Constants.DOUBLE)) || 
      (this.dataType.equals(Constants.DOUBLENOISE)) || 
      (this.dataType.equals(Constants.DOUBLEPRESSUREPA))) {
      ret.put("dataDouble", Double.valueOf(this.myDataDouble));
    }
    else if (this.dataType.equals(Constants.BOOLEAN)) {
      ret.put("dataBoolean", Boolean.valueOf(this.myDataBoolean));
    }
    return ret;
  }

  public static DataDescription deserializeFromJSONObject(JSONObject j)
  {
    DataDescription temp = new DataDescription();
    temp.address = j.get("address").toString();
    temp.name = j.get("name").toString();
    temp.concept = j.get("concept").toString();
    temp.globalRegion = j.get("global_region").toString();
    temp.sensor = j.get("sensor").toString();
    temp.dataString = j.get("dataString").toString();
    temp.deviceID = j.get("DeviceId").toString();
    temp.unit = j.get("unit").toString();
    temp.dataType = j.get("dataType").toString();
    temp.xCoordinate = Double.parseDouble(j.get("xCoordinate").toString());
    temp.yCoordinate = Double.parseDouble(j.get("yCoordinate").toString());
    if ((j.get("dataType").equals(Constants.DOUBLE)) || 
      (j.get("dataType").equals(Constants.DOUBLENOISE)) || 
      (j.get("dataType").equals(Constants.DOUBLESOUND)) || 
      (j.get("dataType").equals(Constants.DOUBLETEMPERATUREC)) || 
      (j.get("dataType").equals(Constants.DOUBLETEMPERATUREF)) || 
      (j.get("dataType").equals(Constants.DOUBLEPRESSUREPA))) {
      temp.myDataDouble = 
        Double.parseDouble(j.get("dataDouble").toString());
    }
    else if (j.get("dataType").equals(Constants.DOUBLE2DLOCATION)) {
      temp.myDataDouble1 = Double.parseDouble(j.get("dataDouble1")
        .toString());
      temp.myDataDouble2 = Double.parseDouble(j.get("dataDouble2")
        .toString());
    }
    else if (j.get("dataType").equals(Constants.BOOLEAN)) {
      temp.myDataBoolean = ((Boolean)j.get("dataBoolean")).booleanValue();
    }

    return temp;
  }
}