package org.ow2.choreos.iots.common;

import java.util.Hashtable;
import java.util.Map;

public class Location
{
  static Map<String, Double> locationAndAreaMap = new Hashtable();
  static Map<String, BorderPoints> locationAndAreaCoords = new Hashtable();
  double myArea;
  String myName;
  double xCoordinate;
  double yCoordinate;
  long myTime;
  BorderPoints myBorderPoints;
  String myLocationType;
  Point bottomLeft;
  Point upperRight;

  static
  {
    locationAndAreaMap.put("Paris", Double.valueOf(1771500.0D));
    locationAndAreaMap.put("Airport", Double.valueOf(10000.0D));
    locationAndAreaMap.put("Louvre", Double.valueOf(60.600000000000001D));

    locationAndAreaCoords.put("Beijing", new BorderPoints(new Point(
      5725.46D, 4436.8800000000001D), new Point(5764.9799999999996D, 4436.8800000000001D), new Point(
      5725.46D, 4481.3599999999997D), new Point(5764.9799999999996D, 4481.3599999999997D)));
    locationAndAreaCoords.put("Paris", new BorderPoints(new Point(
      2411.6999999999998D, 250.19999999999999D), new Point(2415.5999999999999D, 250.19999999999999D), new Point(
      2411.6999999999998D, 267.89999999999998D), new Point(2415.5999999999999D, 267.89999999999998D)));
    locationAndAreaCoords.put("Louvre", new BorderPoints(new Point(
      2413.1900000000001D, 259.06D), new Point(2413.6799999999998D, 259.06D), new Point(
      2413.1900000000001D, 260.19999999999999D), new Point(2413.6799999999998D, 260.19999999999999D)));
  }

  public Location(String name)
  {
    this.myName = name;
    this.myLocationType = "area";
  }

  public Location(String name, double xCoord, double yCoord)
  {
    this.myName = name;
    this.xCoordinate = xCoord;
    this.yCoordinate = yCoord;
    this.myLocationType = "point";
  }

  public Location(String name, Point bottomLeft, Point upperRight)
  {
    this.myName = name;
    this.bottomLeft = bottomLeft;
    this.upperRight = upperRight;
    this.myLocationType = "area";
  }

  public Point getBottomLeft() {
    return this.bottomLeft;
  }

  public Point getUpperRight() {
    return this.upperRight;
  }

  public Location(String name, BorderPoints areaPoints)
  {
    this.myName = name;
    this.myBorderPoints = areaPoints;
    this.myLocationType = "area";
  }

  public Location(String name, double area)
  {
    this.myName = name;
    this.myArea = area;
  }

  public String getLocationType() {
    return this.myLocationType;
  }

  public Location(double x, double y, long totalDispTime)
  {
    this.xCoordinate = x;
    this.yCoordinate = y;
    this.myTime = totalDispTime;
  }

  public long getTime() {
    return this.myTime;
  }

  public double getArea()
  {
    this.myArea = ((Double)locationAndAreaMap.get(this.myName)).doubleValue();
    return this.myArea;
  }

  public void setArea(double value) {
    this.myArea = value;
  }

  public String getLocationName() {
    return this.myName;
  }

  public Double getXCoordinate() {
    return Double.valueOf(this.xCoordinate);
  }

  public Double getYCoordinate() {
    return Double.valueOf(this.yCoordinate);
  }

  public void setXYCoordinates(double x, double y) {
    this.xCoordinate = x;
    this.yCoordinate = y;
  }

  public BorderPoints getBorderPoints() {
    return this.myBorderPoints;
  }

  public BorderPoints getBorderPoints(String location) {
    return (BorderPoints)locationAndAreaCoords.get(location);
  }
}