package org.ow2.choreos.iots.common;

import java.util.ArrayList;
import org.ow2.choreos.iots.datatypes.DefaultDouble2dLocationData;

public class Service
{
  String myType;
  String mySensorType;
  String myAddress;
  String myTypeOfCoverage;
  double myProbabilityThreshold;
  double mySensingRange;
  double myRequiredAccuracy;
  double mySensingAccuracy;
  ArrayList<Location> myEstimatedPath;
  String myEstimatedPathString;
  double myRequiredNeighbors;
  Location myCoveredLocation;
  Location myGlobalLocation;
  DefaultDouble2dLocationData myLocation;
  String myPhysicalConcept;
  String myMeasuredDataType;
  double myCoordinateX;
  double myCoordinateY;
  String myName;
  String myDeviceId;
  String myUnit;

  public Service(String deviceId, String serviceName, String serviceType, double sensingAccuracy, String sensorType, String concept, double sensingRange, double requiredProbabilityThreshold, String accessAddress, String measuredDataType, double locationCoordinateX, double locationCoordinateY, String unit)
  {
    this.myType = serviceType;
    this.myName = serviceName;
    this.mySensingAccuracy = sensingAccuracy;
    this.mySensorType = sensorType;
    this.mySensingRange = sensingRange;
    this.myProbabilityThreshold = requiredProbabilityThreshold;
    this.myPhysicalConcept = concept;
    this.myDeviceId = deviceId;
    this.myAddress = accessAddress;
    this.myMeasuredDataType = measuredDataType;
    this.myCoordinateX = locationCoordinateX;
    this.myCoordinateY = locationCoordinateY;
    this.myUnit = unit;
  }

  public String getServiceName()
  {
    return this.myName;
  }

  public String getDeviceId() {
    return this.myDeviceId;
  }

  public String getUnit() {
    return this.myUnit;
  }

  public Location getGlobalRegion()
  {
    return this.myGlobalLocation;
  }

  public void setGlobalRegion(Location loc) {
    this.myGlobalLocation = loc;
  }

  public DefaultDouble2dLocationData getLocationCoordinates()
  {
    return this.myLocation;
  }

  public String getMeasuredDataType() {
    return this.myMeasuredDataType;
  }

  public void setLocation(DefaultDouble2dLocationData xyCoordinates) {
    this.myLocation = xyCoordinates;
  }

  public void setCoordinateX(double x) {
    this.myCoordinateX = x;
  }

  public double getCoordinateX() {
    return this.myCoordinateX;
  }

  public void setCoordinateY(double y) {
    this.myCoordinateY = y;
  }

  public double getCoordinateY() {
    return this.myCoordinateY;
  }

  public void setUnit(String unit) {
    this.myUnit = unit;
  }

  public ArrayList<Location> getEstimatedPath()
  {
    return this.myEstimatedPath;
  }

  public String getServiceType() {
    return this.myType;
  }

  public double getServiceAccuracy() {
    return this.mySensingAccuracy;
  }

  public String getTypeOfServiceSensor() {
    return this.mySensorType;
  }

  public double getServiceRange() {
    return this.mySensingRange;
  }

  public double getServiceProbThreshold() {
    return this.myProbabilityThreshold;
  }

  public String getServiceAddress()
  {
    return this.myAddress;
  }

  public String getConcept() {
    return this.myPhysicalConcept;
  }

  public void setEstimatedPath(ArrayList<Location> path)
  {
    this.myEstimatedPath = path;
    this.myEstimatedPathString = "";
    int counter = 0;
    for (Location l : path)
    {
      if (counter == 0)
        this.myEstimatedPathString = 
          (l.getXCoordinate() + "," + 
          l.getYCoordinate() + "," + l.getTime());
      else
        this.myEstimatedPathString = 
          (this.myEstimatedPathString + ";" + l.getXCoordinate() + "," + 
          l.getYCoordinate() + "," + l.getTime());
      counter++;
    }
  }

  public String getEstimatedPathString()
  {
    return this.myEstimatedPathString;
  }

  public void setGlobalRegion(String region)
  {
    this.myGlobalLocation = new Location(region);
  }
}