package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;
import org.ow2.choreos.iots.common.Constants;

public abstract class BooleanData extends SensorData
{
  private static final long serialVersionUID = -6067451962406761846L;
  protected final Boolean value;
  private static final String VALUE = Constants.BOOLVALUE;

  public BooleanData(JSONObject j) { super(j);
    this.value = ((Boolean)j.get(VALUE)); }

  public BooleanData(Boolean value, long timestamp) {
    super(timestamp);
    this.value = value;
  }

  public Boolean getValue() {
    return this.value;
  }

  public String[] toStringArray()
  {
    String[] s = new String[2];
    s[0] = Long.toString(this.timestamp);
    s[1] = this.value.toString();
    return s;
  }

  public JSONObject serializeAsJSON()
  {
    JSONObject ret = super.serializeAsJSON();

    ret.put(VALUE, this.value);

    return ret;
  }
}