package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultBooleanDisplayData extends BooleanData
{
  private static final long serialVersionUID = -6067451962406761846L;
  protected static final String UID = "org.ow2.choreos.sensordata.boolean.display";
  protected static final String INTERFACE = "org.ow2.choreos.sensordata.boolean.display";

  public DefaultBooleanDisplayData(JSONObject j)
  {
    super(j);
  }
  public DefaultBooleanDisplayData(Boolean value, long timestamp) {
    super(value, timestamp);
  }

  public SensorData fromStringArray(String[] sa)
  {
    return new DefaultBooleanDisplayData(Boolean.valueOf(Boolean.parseBoolean(sa[1])), Long.parseLong(sa[0]));
  }

  public String[] getComponentNames()
  {
    String[] s = new String[2];
    s[0] = "timestamp";
    s[1] = "value";
    return s;
  }

  public boolean isFresh()
  {
    return true;
  }

  public SensorData copy()
  {
    return this;
  }

  public String getUid()
  {
    return "org.ow2.choreos.sensordata.boolean.display";
  }

  public String getInterface()
  {
    return "org.ow2.choreos.sensordata.boolean.display";
  }

  public JSONObject serializeAsJSON()
  {
    JSONObject ret = super.serializeAsJSON();

    return ret;
  }

  public String toString()
  {
    return this.value.toString();
  }
}