package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultDouble2dLocationData extends DefaultDouble2dData
{
  private static final long serialVersionUID = -127661348591111955L;
  protected static final String UID = "org.ow2.choreos.sensordata.2d-double.location";
  protected static final String INTERFACE = "org.ow2.choreos..sensordata.2d-double.location";

  public DefaultDouble2dLocationData(JSONObject j)
  {
    super(j);
  }

  public DefaultDouble2dLocationData(double latitude, double longitude, long timestamp) {
    super(latitude, longitude, timestamp);
  }

  public SensorData fromStringArray(String[] sa)
  {
    return new DefaultDouble2dLocationData(Double.parseDouble(sa[0]), 
      Double.parseDouble(sa[1]), Long.parseLong(sa[2]));
  }

  public String[] getComponentNames()
  {
    String[] s = new String[3];
    s[0] = "latitude";
    s[1] = "longitude";
    s[2] = "timestamp";
    return s;
  }

  public String getUid()
  {
    return "org.ow2.choreos.sensordata.2d-double.location";
  }

  public double getLatitude() {
    return super.getX();
  }

  public double getLongitude() {
    return super.getY();
  }

  public JSONObject serializeAsJSON()
  {
    JSONObject ret = super.serializeAsJSON();
    return ret;
  }
}