package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultDouble3dData extends Double3dData
{
  private static final long serialVersionUID = 8205724392915403983L;
  protected static final String UID = "org.ow2.choreos.sensordata.3d-double";
  protected static final String INTERFACE = "org.ow2.choreos.sensordata.3d-double";

  public DefaultDouble3dData(JSONObject j)
  {
    super(j);
  }

  public DefaultDouble3dData(double x, double y, double z, long t) {
    super(x, y, z, t);
  }

  public SensorData fromStringArray(String[] sa)
  {
    return new DefaultDouble3dData(Double.parseDouble(sa[0]), 
      Double.parseDouble(sa[1]), Double.parseDouble(sa[2]), 
      Long.parseLong(sa[3]));
  }

  public String[] toStringArray()
  {
    String[] s = new String[4];
    s[0] = Long.toString(this.timestamp);
    s[1] = Double.toString(this.x);
    s[2] = Double.toString(this.y);
    s[3] = Double.toString(this.z);
    return s;
  }

  public String[] getComponentNames()
  {
    String[] s = new String[4];
    s[0] = "timestamp";
    s[1] = "x";
    s[2] = "y";
    s[3] = "z";
    return s;
  }

  public boolean isFresh()
  {
    return true;
  }

  public String toString()
  {
    return "x:" + Double.toString(this.x) + 
      " y:" + Double.toString(this.y) + 
      " z:" + Double.toString(this.z) + 
      " timestamp:" + Long.toString(this.timestamp);
  }

  public SensorData copy()
  {
    return this;
  }

  public String getUid()
  {
    return "org.ow2.choreos.sensordata.3d-double";
  }

  public String getInterface()
  {
    return "org.ow2.choreos.sensordata.3d-double";
  }

  public JSONObject serializeAsJSON() {
    JSONObject ret = super.serializeAsJSON();

    return ret;
  }
}