package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultDoubleData extends DoubleData
{
  private static final long serialVersionUID = 6927592376981831812L;
  protected static final String UID = "org.ow2.choreos.sensordata.double";
  protected static final String INTERFACE = "org.ow2.choreos.sensordata.double";

  public DefaultDoubleData(JSONObject j)
  {
    super(j);
  }

  public DefaultDoubleData(double value, long timestamp)
  {
    super(value, timestamp);
  }

  public SensorData fromStringArray(String[] sa)
  {
    return new DefaultDoubleData(Double.parseDouble(sa[1]), 
      Long.parseLong(sa[0]));
  }

  public String[] getComponentNames()
  {
    String[] s = new String[2];
    s[0] = "timestamp";
    s[1] = "value";
    return s;
  }

  public boolean isFresh()
  {
    return true;
  }

  public SensorData copy()
  {
    return this;
  }

  public String getUid()
  {
    return "org.ow2.choreos.sensordata.double";
  }

  public String getInterface()
  {
    return "org.ow2.choreos.sensordata.double";
  }

  public JSONObject serializeAsJSON()
  {
    JSONObject ret = super.serializeAsJSON();

    return ret;
  }
}