package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultDoubleNoiseLevelData extends DefaultDoubleData
{
  private static final long serialVersionUID = -3889806809081793607L;
  protected static final String UID = "org.ow2.choreos.sensordata.double.noiselevel";
  protected static final String INTERFACE = "org.ow2.choreos.sensordata.double.noiselevel";

  public DefaultDoubleNoiseLevelData(JSONObject j)
  {
    super(j);
  }

  public DefaultDoubleNoiseLevelData(double noiselevel_dB, long timestamp) {
    super(noiselevel_dB, timestamp);
  }

  public SensorData fromStringArray(String[] sa)
  {
    return new DefaultDoubleNoiseLevelData(Double.parseDouble(sa[1]), Long.parseLong(sa[0]));
  }

  public String[] getComponentNames()
  {
    String[] s = new String[2];
    s[0] = "timestamp";
    s[1] = "db";
    return s;
  }

  public String getUid()
  {
    return "org.ow2.choreos.sensordata.double.noiselevel";
  }

  public double getNoiseLevel() {
    return super.getValue();
  }

  public JSONObject serializeAsJSON()
  {
    JSONObject ret = super.serializeAsJSON();

    return ret;
  }
}