package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultDoubleSoundData extends DefaultDoubleData
{
  protected static final String UID = "org.ow2.choreos.sensordata.double.sound";
  protected static final String INTERFACE = "org.ow2.choreos.sensordata.double.sound";

  public DefaultDoubleSoundData(JSONObject j)
  {
    super(j);
  }

  public DefaultDoubleSoundData(double sound_dB, long timestamp) {
    super(sound_dB, timestamp);
  }

  public SensorData fromStringArray(String[] sa)
  {
    return new DefaultDoubleSoundData(Double.parseDouble(sa[1]), Long.parseLong(sa[0]));
  }

  public String[] getComponentNames()
  {
    String[] s = new String[2];
    s[0] = "timestamp";
    s[1] = "db";
    return s;
  }

  public String getUid()
  {
    return "org.ow2.choreos.sensordata.double.sound";
  }

  public double getNoiseLevel() {
    return super.getValue();
  }

  public JSONObject serializeAsJSON()
  {
    JSONObject ret = super.serializeAsJSON();

    return ret;
  }
}