package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultDoubleTemperatureCelsiusData extends DefaultDoubleData
{
  private static final long serialVersionUID = -3889806809081793607L;
  protected static final String UID = "org.ow2.choreos.sensordata.double.celsius.temperature";
  protected static final String INTERFACE = "org.ow2.choreos.sensordata.double.celsius.temperature";

  public DefaultDoubleTemperatureCelsiusData(JSONObject j)
  {
    super(j);
  }

  public DefaultDoubleTemperatureCelsiusData(double noiselevel_dB, long timestamp) {
    super(noiselevel_dB, timestamp);
  }

  public SensorData fromStringArray(String[] sa)
  {
    return new DefaultDoubleTemperatureCelsiusData(Double.parseDouble(sa[1]), Long.parseLong(sa[0]));
  }

  public String[] getComponentNames()
  {
    String[] s = new String[2];
    s[0] = "timestamp";
    s[1] = "degreeC";
    return s;
  }

  public String getUid()
  {
    return "org.ow2.choreos.sensordata.double.celsius.temperature";
  }

  public double getNoiseLevel() {
    return super.getValue();
  }

  public JSONObject serializeAsJSON()
  {
    JSONObject ret = super.serializeAsJSON();

    return ret;
  }
}