package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;

public class DefaultLongData extends LongData
{
  private static final long serialVersionUID = -2532635367118000720L;
  protected static final String UID = "org.ow2.choreos.sensordata.long";
  protected static final String INTERFACE = "org.ow2.choreos.sensordata.long";

  public DefaultLongData(JSONObject j)
  {
    super(j);
  }

  public DefaultLongData(long value, long timestamp)
  {
    super(value, timestamp);
  }

  public SensorData fromStringArray(String[] sa)
  {
    return new DefaultLongData(Long.parseLong(sa[1]), Long.parseLong(sa[0]));
  }

  public String[] getComponentNames()
  {
    String[] s = new String[2];
    s[0] = "timestamp";
    s[1] = "value";
    return s;
  }

  public boolean isFresh()
  {
    return true;
  }

  public SensorData copy()
  {
    return this;
  }

  public String getUid()
  {
    return "org.ow2.choreos.sensordata.long";
  }

  public String getInterface()
  {
    return "org.ow2.choreos.sensordata.long";
  }

  public JSONObject serializeAsJSON() {
    JSONObject ret = super.serializeAsJSON();

    return ret;
  }
}