package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;
import org.ow2.choreos.iots.common.Constants;

public abstract class Double2dData extends SensorData
{
  private static final long serialVersionUID = 5508555229342582371L;
  protected final double x;
  protected final double y;
  private static final String X = Constants.XVAL;
  private static final String Y = Constants.YVAL;

  public Double2dData(JSONObject j)
  {
    super(j);
    this.x = Double.parseDouble(j.get(X).toString());
    this.y = Double.parseDouble(j.get(Y).toString());
  }

  public Double2dData(double x, double y, long t)
  {
    super(t);
    this.x = x;
    this.y = y;
  }

  public double getX() {
    return this.x;
  }

  public double getY() {
    return this.y;
  }

  public String toString()
  {
    return "x:" + Double.toString(this.x) + " y:" + Double.toString(this.y) + 
      " timestamp:" + Long.toString(this.timestamp);
  }

  public String[] toStringArray()
  {
    String[] s = new String[3];
    s[0] = Double.toString(this.x);
    s[1] = Double.toString(this.y);
    s[2] = Long.toString(this.timestamp);
    return s;
  }

  public JSONObject serializeAsJSON() {
    JSONObject ret = super.serializeAsJSON();

    ret.put(X, Double.valueOf(this.x));
    ret.put(Y, Double.valueOf(this.y));
    return ret;
  }
}