package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;
import org.ow2.choreos.iots.common.Constants;

public abstract class Double3dData extends SensorData
{
  private static final long serialVersionUID = 8205724392915403983L;
  protected final double x;
  protected final double y;
  protected final double z;
  private static final String X = Constants.XVAL;
  private static final String Y = Constants.YVAL;
  private static final String Z = Constants.ZVAL;

  public Double3dData(JSONObject j) {
    super(j);
    this.x = Double.parseDouble(j.get(X).toString());
    this.y = Double.parseDouble(j.get(Y).toString());
    this.z = Double.parseDouble(j.get(Z).toString());
  }

  public Double3dData(double x, double y, double z, long t) {
    super(t);
    this.x = x;
    this.y = y;
    this.z = z;
  }

  public double getX() {
    return this.x;
  }

  public double getZ() {
    return this.z;
  }

  public double getY() {
    return this.y;
  }

  public String toString()
  {
    return "x:" + Double.toString(this.x) + 
      " y:" + Double.toString(this.y) + 
      " z:" + Double.toString(this.z) + 
      " timestamp:" + Long.toString(this.timestamp);
  }

  public String[] toStringArray()
  {
    String[] s = new String[4];
    s[0] = Long.toString(this.timestamp);
    s[1] = Double.toString(this.x);
    s[2] = Double.toString(this.y);
    s[3] = Double.toString(this.z);
    return s;
  }
  public JSONObject serializeAsJSON() {
    JSONObject ret = super.serializeAsJSON();
    ret.put(X, Double.valueOf(this.x));
    ret.put(Y, Double.valueOf(this.y));
    ret.put(Z, Double.valueOf(this.z));
    return ret;
  }
}