package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;
import org.ow2.choreos.iots.common.Constants;

public abstract class DoubleData extends SensorData
{
  private static final long serialVersionUID = 6927592376981831812L;
  protected final double value;
  private static final String VALUE = Constants.DOUBLEVALUE;

  public DoubleData(JSONObject j)
  {
    super(j);
    this.value = Double.parseDouble(j.get(VALUE).toString());
  }

  public DoubleData(double value, long timestamp) {
    super(timestamp);
    this.value = value;
  }

  public double getValue() {
    return this.value;
  }

  public String toString()
  {
    return Double.toString(this.value);
  }

  public String[] toStringArray()
  {
    String[] s = new String[2];
    s[0] = Long.toString(this.timestamp);
    s[1] = Double.toString(this.value);
    return s;
  }

  public JSONObject serializeAsJSON()
  {
    JSONObject ret = super.serializeAsJSON();

    ret.put(VALUE, Double.valueOf(this.value));

    return ret;
  }
}