package org.ow2.choreos.iots.datatypes;

import org.json.simple.JSONObject;
import org.ow2.choreos.iots.common.Constants;

public abstract class LongData extends SensorData
{
  private static final long serialVersionUID = -2532635367118000720L;
  protected final long value;
  private static final String VALUE = Constants.LONGVALUE;

  public LongData(JSONObject j)
  {
    super(j);
    this.value = Long.parseLong(j
      .get(VALUE).toString());
  }
  public LongData(long value, long timestamp) {
    super(timestamp);
    this.value = value;
  }

  public long getValue() {
    return this.value;
  }

  public String toString()
  {
    return Long.toString(this.value);
  }

  public String[] toStringArray()
  {
    String[] s = new String[2];
    s[0] = Long.toString(this.timestamp);
    s[1] = Long.toString(this.value);
    return s;
  }

  public JSONObject serializeAsJSON() {
    JSONObject ret = super.serializeAsJSON();

    ret.put(VALUE, Long.valueOf(this.value));

    return ret;
  }
}