package org.ow2.choreos.iots.datatypes;

import java.io.Serializable;
import org.json.simple.JSONObject;
import org.ow2.choreos.iots.common.Constants;
import org.ow2.choreos.iots.semantics.SemanticClass;

public abstract class SensorData extends SemanticClass
  implements Serializable
{
  private static final long serialVersionUID = 1963099439953813653L;
  private static final String T = Constants.TVAL;
  public long timestamp;

  protected SensorData()
  {
  }

  protected SensorData(JSONObject j)
  {
    super(j);
    this.timestamp = Long.parseLong(j.get(T).toString());
  }

  protected SensorData(long timestamp)
  {
    this.timestamp = timestamp;
  }

  public abstract boolean isFresh();

  public abstract String toString();

  public abstract SensorData copy();

  public abstract String[] getComponentNames();

  public abstract String[] toStringArray();

  public abstract SensorData fromStringArray(String[] paramArrayOfString);

  public JSONObject serializeAsJSON()
  {
    JSONObject ret = new JSONObject();

    ret.put(T, Long.valueOf(this.timestamp));

    return ret;
  }
}