package org.ow2.choreos.registration.impl;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import java.sql.PreparedStatement;

import org.ow2.choreos.iots.common.DensityPerType;
import org.ow2.choreos.iots.common.Location;
import org.ow2.choreos.iots.common.Sensor;
import org.ow2.choreos.iots.common.Service;
import org.ow2.choreos.iots.common.SubstituteSensorSet;
import org.ow2.choreos.distributions.Constants;
import org.ow2.choreos.registration.interfaces.RegistrationEstimator;
import org.ow2.choreos.registration.interfaces.SubstituteSetsGenerator;
import org.ow2.choreos.registryclient.impl.RegistryClientManager;
import org.ow2.choreos.registryclient.interfaces.RegistryClient;

import android.util.Log;



import fr.inria.arles.thinglib.RESTAccess.Static_Addresses;

//TODO send area to registry , keep in mind what area we be liked
public class RegistrationEstimatorImpl implements RegistrationEstimator {
	static String TAG = "RegistrationEstimator";

	boolean registered;
	static Statement readStatement, insertStatement;
	static String MOBILITYMODEL = "RandomWalk";

	static ArrayList<Location> myEstimatedPath;

	public double getCoverageAreaPerNode() {
		// TODO Auto-generated method stub
		return 0;
	}

	// static ArrayList<Location> myEstimatedPath = new ArrayList<Location>();
	@Override
	/**
	 * This method is called by the Registration Manager and passes a service object to the 
	 * probability estimator to perform its mathematical calculations. It takes the new threshold value
	 * and decides whether the device should register this service or not.
	 * @param phoneService: the service being evaluated
	 * @return: true if the service registered successfully, false otherwise.
	 * @throws IOException
	 */
	public boolean registerMe(Service phoneService) throws IOException {
		double finalProbVal;
		myEstimatedPath = new ArrayList<Location>();
		// Map<Integer, ArrayList<Double>> locationsPathCoordinates =
		// phoneService
		// .getEstimatedPath();
		// Number Of Locations is actually the number of locations in the nodes
		// estimated path, given that
		// the actual location doesn t matter, and we are hard coding it for
		// now, it makes more sense to just
		// hardcode the number
		int numberOfLocations = 1;

		// TODO: change to a location object
		/*
		 * ArrayList<Double> locationXYCoordinates = new ArrayList<Double>();
		 * locationXYCoordinates.add(0.0); locationXYCoordinates.add(0.0);
		 * phoneService.setLocation(locationXYCoordinates);
		 */

		//phoneService.setCoordinateX(phoneService.getCoordinateX());
		//phoneService.setCoordinateY(phoneService.getCoordinateY());

		// TODO: estimated path is sent from somewhere
		/*
		 * Location l0 = new Location("l0", 1, 1); Location l1 = new
		 * Location("l1", 2, 3); Location l2 = new Location("l2", 3, 4);
		 * 
		 * 
		 * myEstimatedPath.add(l0); myEstimatedPath.add(l1);
		 * myEstimatedPath.add(l2);
		 */

		Map<Integer, SubstituteSensorSet> setsOfSubSensors = new HashMap<Integer, SubstituteSensorSet>();
		ArrayList<String> conceptsOfInterest = new ArrayList<String>();
		SubstituteSetsGenerator mySetGenerator = new SubstituteSetsGeneratorImpl();

		mySetGenerator.initialize();

		try {
			setsOfSubSensors = mySetGenerator.getSubstitutionSets(
					phoneService.getTypeOfServiceSensor(),
					phoneService.getConcept());
			for (Entry<Integer, SubstituteSensorSet> entry : setsOfSubSensors
					.entrySet()) {
				SubstituteSensorSet setOfSubs = entry.getValue();
				for (int i = 0; i < setOfSubs.getAllConcepts().size(); i++)
					conceptsOfInterest.add(setOfSubs.getAllConcepts().get(i));
			}
		} catch (NullPointerException e) {
			System.out
					.println("RegistrationEstimator.registerMe: getSubstitutionSets returned a null set");
			return false;
		}
		try {
			// TODO add requestNumberOfNodes based on area not paris
			phoneService.setGlobalRegion(new Location("Paris"));
			HashMap<String, Double> numberOfNodesPerType = requestNumberOfNodes(
					Static_Addresses.REGISTRY_URL, conceptsOfInterest, phoneService
							.getGlobalRegion().getLocationName(),
					phoneService.getDeviceId());

			finalProbVal = generateRegProbVal(setsOfSubSensors,
					numberOfNodesPerType, numberOfLocations,
					phoneService.getServiceProbThreshold(),
					phoneService.getGlobalRegion(), phoneService);
		} catch (NullPointerException e) {
			System.out
					.println("RegistrationEstimator.registerMe: requestNumberOfNodes returned a null result");
			return false;
		}
		boolean decision = generateRegDec(finalProbVal);

		Log.i(TAG, "Decision for registering the service: " + decision);

		if (decision == true) {
			sendRegistrationInformation(phoneService, Static_Addresses.REGISTRY_URL);
			Log.i(TAG, "Registering phone service: " + phoneService
					+ " -- To Registry address: " + Static_Addresses.REGISTRY_URL);
		} else
			try {
				RegistryClient myReg = RegistryClientManager
						.getRegistry(Static_Addresses.REGISTRY_URL);

				myReg.removeServiceReq(phoneService);
			}

			catch (NullPointerException e) {
				System.out.println("device not registered");
				return false;
			}

		return decision;

	}
	
	/**
	 * This method removes a service from the registry
	 * @param phoneService: the service being evaluated
	 * @return: true if the service is unregistered successfully, false otherwise.
	 * @throws IOException
	 */
	public boolean unRegisterMe(Service phoneService) throws IOException {
		phoneService.setCoordinateX(0);
		phoneService.setCoordinateY(0);
		boolean decision = false;
			try {
				RegistryClient myReg = RegistryClientManager
						.getRegistry(Static_Addresses.REGISTRY_URL);

				myReg.removeServiceReq(phoneService);
				decision = true;
			}catch (NullPointerException e) {
				System.out.println("device not registered");
				decision = false;
			}
		return decision;
	}

	public static ArrayList<DensityPerType> getDensities(
			HashMap<String, Double> numberOfNodesPerType,
			Location globalLocation) {
		String sensorType = "";
		ArrayList<DensityPerType> densities = null;
		if (numberOfNodesPerType != null) {
			densities = new ArrayList<DensityPerType>();
			for (Entry<String, Double> entry : numberOfNodesPerType.entrySet()) {
				sensorType = entry.getKey().toString();
				// Sensor mySensor = new Sensor(sensorType,1);
				double sensorDensity = entry.getValue()
						/ globalLocation.getArea();
				DensityPerType poisPerType = new DensityPerType(sensorType,
						sensorDensity);
				densities.add(poisPerType);

			}
		} else {
			System.out
					.println("RegistrationEstimator.getDensities:  numberOfNodesPerType is null");
			return null;
		}

		return densities;

	}

	public static boolean generateRegDec(double probVal) {
		boolean decision = false;
		double r = Math.random();
		if (r < probVal)
			decision = true;
		else
			decision = false;
		System.out.println("the newThreshold is: " + probVal
				+ " and decision is" + decision);

		return decision;

	}

	public static double generateRegProbVal(
			Map<Integer, SubstituteSensorSet> setsOfSubSensors,
			HashMap<String, Double> numberOfNodesByType, int numberOfLocations,
			double probThreshold, Location myGlobalLocation, Service ps)
			throws IOException {

		double newThreshold = 0;
		Sensor phoneSensor = new Sensor(ps.getTypeOfServiceSensor(),
				ps.getConcept(), ps.getServiceRange());
		try {
			ArrayList<DensityPerType> densities = getDensities(
					numberOfNodesByType, myGlobalLocation);

			ProbabilityEstimatorImpl PE = new ProbabilityEstimatorImpl();
			if (densities != null && MOBILITYMODEL.equals("RandomWalk"))
				newThreshold = PE.generateNewThresholdRandomWalk(densities,
						phoneSensor, (numberOfLocations), probThreshold,
						setsOfSubSensors);
			/*
			 * else if (densities != null &&
			 * Constants.MOBILITYMODEL.equals("LevyWalk")) newThreshold =
			 * PE.generateNewThresholdLevyWalk(numberOfNodesByType, phoneSensor,
			 * probThreshold, setsOfSubSensors, myEstimatedPath);
			 */

		} catch (NullPointerException e) {
			System.out
					.println("RegistrationEstimator.generateRegProbVal: getDensities returned a null result");
			return 0;
		}
		return newThreshold;
	}

	public static boolean sendRegistrationInformation(Service ps,
			String registryAddress) {
		ps.getServiceAddress();
		RegistryClient myReg = RegistryClientManager
				.getRegistry(registryAddress);

		return myReg.registerServiceReq(ps);
	}

	public static HashMap<String, Double> requestNumberOfNodes(
			String registryAddress, ArrayList<String> myConcepts,
			String locationOfInterest, String deviceId) {
		HashMap<String, Double> result = new HashMap<String, Double>();

		try {
			RegistryClient myReg = RegistryClientManager
					.getRegistry(registryAddress);
			try {
				result = myReg.findNumberOfServicesReq(myConcepts,
						locationOfInterest, deviceId);
			} catch (NullPointerException e) {
				System.out
						.println("RegistrationEstimatorImpl.requestNumberOfNodes: could not get the number of registered services");
				e.printStackTrace();
				return null;
			}
		}

		catch (NullPointerException e) {
			System.out
					.println("RegistrationEstimator.requestNumberOfNodes: no registry found");
			return null;
		}

		return result;

	}

}
