package org.ow2.choreos.registration.interfaces;

import java.util.Map;

import org.ow2.choreos.iots.common.SubstituteSensorSet;





public interface SubstituteSetsGenerator {

	//public void initialize() ;
	/**
	 * This method is used to generate a set of sensors that, based on some mathematical computations
	 * over their measurements, can substitute a sensor of interest. This set is defined in an ontology
	 * @param initSensorType: the initial sensor type to be substituted
	 * @param initSensorConcept: the initial physical concept measured by the sensor
	 * @return a HashMap containing all substitute sets acquired from the ontology and their ids (the ids 
	 * are provided by the method itself)
	 */
	public Map<Integer, SubstituteSensorSet> getSubstitutionSets(String initSensorType, String initSensorConcept);

	/**
	 * the method is used to read the ontology and parse it into memory
	 */
	public void initialize();
	
}
