package org.ow2.choreos.iots.graphical;

/**
 compiling and running
 D:\tmp>javac DrawPoints.java

 D:\tmp>java -cp . DrawPoints
 */
import java.util.List;
import java.util.ArrayList;
import java.awt.*;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.IOException;

import javax.swing.*;

import org.ow2.choreos.iots.Objects.CoordinatePoint;


public class DrawPoints extends JFrame {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	// the size of the viewport
	static int X_SIZE = 1000;
	static final int Y_SIZE = 1000;
	// public static String ROOTPATH = "/Users/shachem/Desktop/";
	double sharedScaleFactor;
	// static final double LONGSCALINGFACTOR = 49.4;
	// static final double LATSCALINGFACTOR = 111.2;

	static double radius = 1;
	static double xMin = 0;
	// static double xMax = 116.8;
	static double xMax = 10;

	static double yMin = 0;
	// static double yMax = 40.2;
	static double yMax = 10;
	static double xIncrementFactor = 0.1;
	static double yIncrementFactor = 0;
	static DrawPointsPanel drawingArea;

	// CSVReader readerCoords = new CSVReader(new FileReader(ROOTPATH
	// + "newtraces-animesh.csv"));
	// String[] nextLineCoords = readerCoords.readNext();
	public static void main(String[] args) throws IOException {
		CoordinatePoint c1 = new CoordinatePoint(2, 2);
		CoordinatePoint c2 = new CoordinatePoint(3,6);
		CoordinatePoint c3 = new CoordinatePoint(4, 2);
		CoordinatePoint c4 = new CoordinatePoint(4, 4);
		CoordinatePoint c5 = new CoordinatePoint(4, 6);

		ArrayList<CoordinatePoint> points = new ArrayList<CoordinatePoint>();
		points.add(c1);
		points.add(c2);
		points.add(c3);
		points.add(c4);
		points.add(c5);

		new DrawPoints(points);
	}

	// xMin=116.1 xMax= 116.80000000000001 yMin = 39.9 yMax = 40.2 radius = 2.0

	public DrawPoints(ArrayList<CoordinatePoint> points) throws IOException {

		super("Using DrawPoints with Borders");

		// WindowUtilities.setNativeLookAndFeel();
		// addWindowListener(new ExitListener());
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container content = getContentPane();
		content.setBackground(Color.lightGray);

		KeyboardFocusManager manager = KeyboardFocusManager
				.getCurrentKeyboardFocusManager();
		manager.addKeyEventDispatcher(new MyDispatcher());
		drawingArea = new DrawPointsPanel(xMin, xMax, yMin, yMax, radius,
				points);
		drawingArea.setPreferredSize(new Dimension(X_SIZE, Y_SIZE));
		drawingArea.setBorder(BorderFactory.createLineBorder(Color.blue, 2));
		drawingArea.setBackground(Color.white);
		content.add(drawingArea);
		drawingArea.addMouseListener(new MouseListener() {

			public void mouseClicked(MouseEvent e) {
				System.out.println("clicked");
				PointerInfo a = MouseInfo.getPointerInfo();
				Point point = new Point(a.getLocation());
				SwingUtilities.convertPointFromScreen(point, e.getComponent());
				int x = (int) point.getX();
				int y = (int) point.getY();
				System.out.println("pixel of x is " + x + " x coordinate is "
						+ (xMin + x / (sharedScaleFactor)) + "pixel of y is "
						+ y + " y coordinate is "
						+ (yMin + y / (sharedScaleFactor)));

			}

			public void mouseEntered(MouseEvent arg0) {
				// TODO Auto-generated method stub

			}

			public void mouseExited(MouseEvent arg0) {
				// TODO Auto-generated method stub

			}

			public void mousePressed(MouseEvent arg0) {
				// TODO Auto-generated method stub

			}

			public void mouseReleased(MouseEvent arg0) {
				// TODO Auto-generated method stub

			}

		});
		// call the point generating code here.

		pack();
		setVisible(true);

	}

	/** Class that draws points */
	class DrawPointsPanel extends JPanel {

		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		double minx, maxx, miny, maxy, scaledRadius;
		List<CoordinatePoint> points;

		// the number each X and Y value will be multiplied by before rendering
		// the point
		double scalefactor;
		BufferedImage image;

		public DrawPointsPanel(double minx, double maxx, double miny,
				double maxy, double radius, List<CoordinatePoint> points) {
			this.minx = minx;
			this.maxx = maxx;
			this.miny = miny;
			this.maxy = maxy;
			this.points = points;

			X_SIZE = (int) (((double) Y_SIZE * (maxx - minx)) / (maxy - miny));

			this.scalefactor = Math.min((double) X_SIZE / (maxx - minx),
					(double) Y_SIZE / (maxy - miny));

			// System.out.println("the scale factor is " + this.scalefactor);
			sharedScaleFactor = this.scalefactor;

			this.scaledRadius = radius * this.scalefactor;

		}

		public void setRadius(double newRadius) {
			this.scaledRadius = newRadius * this.scalefactor;
		}

		public void paintComponent(Graphics g) {
			Graphics2D g2d = (Graphics2D) g;
			for (CoordinatePoint p : this.points) {
				Rectangle2D.Double rec = new Rectangle2D.Double(
						this.scalefactor * (p.getX() - this.minx)
								- this.scaledRadius, this.scalefactor
								* (this.maxx - p.getY() - this.miny) - this.scaledRadius,
						2 * this.scaledRadius, 2 * this.scaledRadius);

				g2d.fill(rec);
			}
		}

		public void printAll() {
			System.out.println("xMin=" + this.minx + " xMax= " + this.maxx
					+ " yMin = " + this.miny + " yMax = " + this.maxy
					+ " radius = " + this.scaledRadius / this.scalefactor);
		}

		public void setBoundaries(double xmin, double xmax, double ymin,
				double ymax) {
			this.minx = xmin;
			this.miny = ymin;
			this.maxx = xmax;
			this.maxy = ymax;
			this.scalefactor = Math.min((double) X_SIZE / (maxx - minx),
					(double) Y_SIZE / (maxy - miny));
			// System.out.println("the scale factor is " + this.scalefactor);
			sharedScaleFactor = this.scalefactor;
			this.scaledRadius = radius * this.scalefactor;

		}

		public void setPoints(List<CoordinatePoint> points) {
			this.points = points;
		}

	}

	private class MyDispatcher implements KeyEventDispatcher {

		public boolean dispatchKeyEvent(KeyEvent e) {

			Container content = getContentPane();

			// content.removeAll();
			content.setBackground(Color.lightGray);

			switch (e.getKeyCode()) {
			case KeyEvent.VK_UP:
				if (e.getID() == KeyEvent.KEY_RELEASED) {
					radius = radius + 1;
					// System.out.println(radius);
					drawingArea.setRadius(radius);
					drawingArea.printAll();
					repaint();

				}
				break;
			case KeyEvent.VK_DOWN:
				if (e.getID() == KeyEvent.KEY_RELEASED) {
					radius = radius - 1;
					// System.out.println(radius);
					drawingArea.setRadius(radius);
					drawingArea.printAll();
					repaint();
				}
				break;
			case KeyEvent.VK_LEFT:
				if (e.getID() == KeyEvent.KEY_RELEASED) {

					xMin = xMin - xIncrementFactor;
					xMax = xMax + xIncrementFactor;
					yMin = yMin - yIncrementFactor;
					yMax = yMax + yIncrementFactor;
					System.out.println("zoom out!");
					drawingArea.setBoundaries(xMin, xMax, yMin, yMax);
					drawingArea.printAll();
					repaint();
				}
				break;
			case KeyEvent.VK_RIGHT:
				if (e.getID() == KeyEvent.KEY_RELEASED) {

					xMin = xMin + xIncrementFactor;
					xMax = xMax - xIncrementFactor;
					yMin = yMin + yIncrementFactor;
					yMax = yMax - yIncrementFactor;
					System.out.println("zoom in!");
					drawingArea.setBoundaries(xMin, xMax, yMin, yMax);
					drawingArea.printAll();
					repaint();
				}
				break;
			}
			return false;
		}

	}
}